require "ISUI/ISLayoutManager"
require "media/lua/client/MyWalkToTimedAction.lua"
local ThePVPButton = ISButton:derive("ThePVPButton");

ErrorMessage = 'None';

if(IsoPlayer.setRealPlayer == nil) then 
--ErrorMessage = 'zombie.zip install not found OR out of date';
end
if(PresetSpawns == nil) then
ErrorMessage = ErrorMessage .. "PresetSpawns.lua could not load, ";
end
if(getOutOfAmmo == nil) then
ErrorMessage = ErrorMessage .. "Dialgue.lua could not load, ";
end
if(SurvivorSpawnRateMultiplier == nil) then
ErrorMessage = ErrorMessage .. "Settings.lua could not load, ";
end

local OrderTo = 0;
local OrderSent = false;
local SelectSent = false;
local Selected = 0;
seenZombie = {};
ROE = 2;
local PVPButton; 

if(Survivors == nil) then Survivors = {}; end

local function isModEnabled(modname)

	local actmods = getActivatedMods();
	for i=0, actmods:size()-1, 1 do
		if actmods:get(i) == modname then
			return true;
		end
	end
	return false;
end

function WalkTo(player,sq)
	if(sq == nil) or (player == nil) then return false end
	
	if(player.WalkTo == nil) then
		player:StopAllActionQueue();
		if(player.setPath2 ~= nil) then
			ISTimedActionQueue.add(ISNewWalkToTimedAction:new(player, sq));
		else
			ISTimedActionQueue.add(ISMyWalkToTimedAction:new(player, sq));
		end
	else
		player:WalkTo(sq:getX(),sq:getY(),sq:getZ());
	end

end

local RareNPCLoot = {

"camping.CampfireKit",
"camping.CampfireKit",
"Base.Map",
"Base.Axe",
"Base.PipeBomb",
"camping.CampingTentKit",
"camping.CampingTentKit",
"Base.HuntingKnife",
"Base.Saw",
"farming.HandShovel",
"Base.Screwdriver",
"Radio.HamRadio1",
"Base.Sledgehammer",
"Base.SmokeBomb",
"Base.PeanutButter"};

if(isModEnabled("ORGM")) then
	table.insert(RareNPCLoot,"ORGM.9mmBox");
	table.insert(RareNPCLoot,"ORGM.M16");
	table.insert(RareNPCLoot,"ORGM.Ber92");
	table.insert(RareNPCLoot,"ORGM.556Box");
else
	table.insert(RareNPCLoot,"Base.Pistol");
end

if(isModEnabled("Hydrocraft")) then
	table.insert(RareNPCLoot,"Hydrocraft.HCShieldriot");
	table.insert(RareNPCLoot,"Hydrocraft.HCDownjacket");
	table.insert(RareNPCLoot,"Hydrocraft.HCTentkit");
	table.insert(RareNPCLoot,"Hydrocraft.HCSleepingbag");
	table.insert(RareNPCLoot,"Hydrocraft.HCSleepingbag");
	table.insert(RareNPCLoot,"Hydrocraft.HCBatterymedium");
	table.insert(RareNPCLoot,"Hydrocraft.HCBatterymedium");
	table.insert(RareNPCLoot,"Hydrocraft.HCMagnesiumstriker");
end

function getRareNPCLoot()
    local result = ZombRand(size(RareNPCLoot)-1)+1;
    return RareNPCLoot[result];
end

local NPCLoot = {"Base.TinnedBeans",
"Base.CannedSardines",
"Base.TinnedSoup",
"Base.Lighter",
"Base.CannedTomato2",
"Base.Bandage",
"Base.TinOpener",
"Base.BathTowel",
"Base.Nails",
"Base.Needle",
"Base.Pot",
"Base.Thread",
"Base.Sheet",
"Base.PillsVitamins",
"Base.Pills",
"Base.Antibiotics",
"Base.Matches",
"Base.CannedBroccoli",
"Base.CannedCarrots",
"Base.CannedLeek",
"Base.CannedPotato",
"Base.KitchenKnife",
"Base.Garbagebag",
"Base.SutureNeedle",
"Base.Splint",
"Base.Radio",
"Base.Torch",
"Base.Crisps2",
"Base.Disinfectant",
"Base.Crisps4",
"Base.Chocolate",
"Base.PopBottle",
"Base.CannedChili",
"Base.CannedBolognese",
"Base.CannedCarrots2",
"Base.CannedChili",
"Base.CannedCorn",
"Base.CannedCornedBeef",
"Base.CannedMushroomSoup",
"Base.CannedPeas",
"Base.WaterBottleFull",
"Base.WaterBottleFull",
"Base.WaterBottleFull",
"Base.WaterBottleFull",
"Base.CannedChili",
"Base.TinnedBeans"};

if(isModEnabled("ORGM")) then
	table.insert(NPCLoot,"ORGM.9mmBox");
	table.insert(NPCLoot,"ORGM.10mmBox");
	table.insert(NPCLoot,"ORGM.57Box");
	table.insert(NPCLoot,"ORGM.556Box");
	table.insert(NPCLoot,"ORGM.38SBox");
	table.insert(NPCLoot,"ORGM.45Box");
	table.insert(NPCLoot,"ORGM.308wBox");
	table.insert(NPCLoot,"ORGM.9mmBox");
else
	table.insert(NPCLoot,"Base.BulletsBox");
	table.insert(NPCLoot,"Base.308Box");
	table.insert(NPCLoot,"Base.223Box");
	table.insert(NPCLoot,"Base.ShotgunShellsBox");
end

if(isModEnabled("Hydrocraft")) then
	table.insert(NPCLoot,"Hydrocraft.HCJackknife");
	table.insert(NPCLoot,"Hydrocraft.HCMeatcleaver");
	table.insert(NPCLoot,"Hydrocraft.HCMasontrowel");
	table.insert(NPCLoot,"Hydrocraft.HCMRE");
	table.insert(NPCLoot,"Hydrocraft.HCTrailmix");
	table.insert(NPCLoot,"Hydrocraft.HCVodka");
	table.insert(NPCLoot,"Hydrocraft.HCWorkgloves");
	table.insert(NPCLoot,"Hydrocraft.HCPliers");
	table.insert(NPCLoot,"Hydrocraft.HCElectricmultitooloff");
	table.insert(NPCLoot,"Hydrocraft.HCSawlumber");
end

function getNPCLoot()
    local result = ZombRand(size(NPCLoot)-1)+1;
    return NPCLoot[result];
end

local NPCBag = {"Base.BigHikingBag",
"Base.Duffelbag",
"Base.Duffelbag",
"Base.Duffelbag",
"Base.NormalHikingBag",
"Base.NormalHikingBag",
"Base.Schoolbag",
"Base.Schoolbag",
"Base.Schoolbag",
"Base.Schoolbag"};

if(isModEnabled("Hydrocraft")) then
	table.insert(NPCBag,"Hydrocraft.HCCampingpack");
	table.insert(NPCBag,"Hydrocraft.HCClimbingpack");
	table.insert(NPCBag,"Hydrocraft.HCBriefcase");
	table.insert(NPCBag,"Hydrocraft.HCDuffelbagpouch");
	table.insert(NPCBag,"Hydrocraft.HCRucksack");
	table.insert(NPCBag,"Hydrocraft.HCTrunk");
	table.insert(NPCBag,"Hydrocraft.HCSchoolbagpouch");
	table.insert(NPCBag,"Hydrocraft.HCSuitcase");
	
end

function giveWeapon(player,weaponType,seenZombie )
	
	local weapon = player:getInventory():AddItem(weaponType);
	if(seenZombie) then player:setPrimaryHandItem(weapon) end
	
	local ammotype = getAmmoBullets(weapon,true);
	if(ammotype) then 
		local tempammoitem = player:getInventory():AddItem(ammotype);
		if(tempammoitem ~= nil) then
			local groupcount = tempammoitem:getCount() ;
			local randomammo = math.floor(ZombRand(25,80)/groupcount);
			
			for i=0, randomammo do
			player:getInventory():AddItem(ammotype);
			end
		end
	end
end

function getNPCBag()
    local result = ZombRand(size(NPCBag)-1)+1;
    return NPCBag[result];
end

SurvivorPerks = {
"Agility",
"Aiming",
"Axe",
"BladeGuard",
"BladeMaintenance",
"Blunt",
"BluntGuard",
"BluntMaintenance",
"Firearm",
"Fitness",
"Lightfoot",
"Melee",
"Nimble",
"PlantScavenging",
"Reloading",
"Sneak",
"Strength",
"Survivalist"}

MarauderPerks = {
"Aiming",
"Axe",
"BladeGuard",
"Blunt",
"BluntGuard",
"Firearm",
"Melee",
"Reloading",
"Strength"}

function getMPerk()
    local result = ZombRand(size(MarauderPerks)-1)+1;
    return MarauderPerks[result];
end


function getPerk()
    local result = ZombRand(size(SurvivorPerks)-1)+1;
    return SurvivorPerks[result];
end

function hasBag(player)
	if not player then return false end
	if not player:getSecondaryHandItem() then return false end
	if player:getSecondaryHandItem():getCategory() == "Container" then return true
	else return false end
end

local function RoundThis(num, idp)
  return tonumber(string.format("%." .. (idp or 0) .. "f", num));
end
function has_value (tab, val)
	if(tab ~= nil) and (val ~= nil) then
		for index, value in ipairs (tab) do
			if value == val then
				return true
			end
		end
	end
    return false
end
function addName(player)
	if(player:getForname() ~= nil and (player:getModData().MetPlayer or player:getModData().ShowName ~= nil)) then return player:getForname()..": ";
	else return "";
	end
end
function DropLootBag(square)
	
	local bag = instanceItem(getNPCBag()) ;
	for i=10,1,-1 do 
		if(ZombRand(2) == 0) then bag:getItemContainer():AddItem(getNPCLoot()); end
	end
	if(ZombRand(2) == 0) then bag:getItemContainer():AddItem(getRareNPCLoot()); end
	square:AddWorldInventoryItem(bag, (ZombRand(1,9)/10), (ZombRand(1,9)/10), 0) ;

end
function FillPlayerInventory(player)
	if(ZombRand(1,10) > 4) then
		local bag = player:getInventory():AddItem(getNPCBag()) ;
		for i=10,1,-1 do 
			if(ZombRand(2) == 0) then bag:getItemContainer():AddItem(getNPCLoot()); end
		end
		if(ZombRand(2) == 0) then bag:getItemContainer():AddItem(getRareNPCLoot()); end
		player:setSecondaryHandItem(bag);
	end
end
function ArraySize(a)
 local i = 1
    while a[i] do
      i = i + 1
    end
	return i;
end
function getFleeSquare(fleeGuy,attackGuy)
	local tempx = (fleeGuy:getX() - attackGuy:getX());      
	local tempy = (fleeGuy:getY() - attackGuy:getY());	
	if (tempx < 0) then tempx = -10; 
	else tempx = 10; end
	if (tempy < 0) then tempy = -10; 
	else tempy = 10; end
	return fleeGuy:getCell():getGridSquare(fleeGuy:getX()+tempx,fleeGuy:getY()+tempy,fleeGuy:getZ());
end

function FindSomeFood(player)
	local SID = player:getModData().ID;
	
	if(Container[SID] ~= nil) and (Container[SID]:getSourceGrid() ~= nil) and (Container[SID]:FindAndReturnCategory("Food") ~= nil) then
		local distance = getDistanceBetween(player,Container[SID]:getSourceGrid());
		--player:Say("have container");
		if(distance > 2.1) then 
			if(player:getPath() == nil) then 
				player:StopAllActionQueue();
				luautils.walkAdj(player, Container[SID]:getSourceGrid()) ;
				--player:Say("Waling walking");
			end
		else
			local item = Container[SID]:FindAndReturnCategory("Food");
			if(item) then
				player:Say("*takes " .. item:getDisplayName() .. " from container and proceeds to eat it*");
				player:getInventory():AddItem(item);
				Container[SID]:Remove(item);
				ISTimedActionQueue.add(ISEatFoodAction:new(player,item,1.00));
				player:getStats():setHunger(player:getStats():getHunger() + item:getHungChange());
				local ASquare = getCell():getGridSquare(player:getModData().PatrolSquareAX,player:getModData().PatrolSquareAY,player:getModData().PatrolSquareAZ);
				
				WalkTo(player,ASquare);
				player:getModData().LookingForFood = nil;
			end
		end
	else
		
		
		local range = 23;
		local Square;
		local minx=math.floor(player:getX() - range);
		local maxx=math.floor(player:getX() + range);
		local miny=math.floor(player:getY() - range);
		local maxy=math.floor(player:getY() + range);
		local closestsoFar = range;
		local gamehours = getGameTime():getWorldAgeHours();
		for x=minx, maxx do
			for y=miny, maxy do
				Square = player:getCell():getGridSquare(x,y,player:getZ());
				if(Square ~= nil) then	
				
					local items = Square:getObjects();
					for j=0, items:size()-1 do
						if(items:get(j):getContainer() ~= nil) then
							
							local container = items:get(j):getContainer();
							distance = getDistanceBetween(player,Square);
							if(container:FindAndReturnCategory("Food") ~= nil) and (distance < closestsoFar) then
								Container[SID] = container;
								closestsoFar = distance;
								
							end	
						end
					end	
					
				end
			end
		end
		--player:Say("closestSoFar:" .. tostring(closestsoFar));
	end
end

function getTheClosestBuilding(player)
local c = player:getCell();
local bl = c:getBuildingList();
local closestSoFar = 10000;
local closestResult = nil;
local tempdistance;
	if(bl ~= nil) then
		for i=0, bl:size()-1 do
			tempdistance = getDistanceBetween(bl:get(i):getFreeTile(),player);
			if((tempdistance < closestSoFar)) then
				closestSoFar = tempdistance ;
				closestResult = bl:get(i);
			else
				player:Say(tostring(tempdistance) .. "!<" .. tostring(closestSoFar));
			end			
		end
	else
		player:Say("no buildings to hide in around here");
	end
	
	if(closestResult ~= nil) then return closestResult; end
end

function DropAll(player)
	local square = player:getCurrentSquare();
	local inv = player:getInventory();
	local pweapon = player:getPrimaryHandItem();
	if(pweapon == nil) then pweapon = 0 end
	local sweapon = player:getSecondaryHandItem();
	if(sweapon == nil) then sweapon = 0 end
	
	local items = inv:getItems() ;
	for i=0, items:size()-1 do
		if(items:get(i) ~= nil) then
			if(not items:get(i):IsClothing()) and (items:get(i) ~= pweapon) and (items:get(i) ~= sweapon) and (items:get(i):getCategory() ~= "Container") then
				square:AddWorldInventoryItem(items:get(i), (ZombRand(1,9)/10) , (ZombRand(1,9)/10), 0.0);
				inv:Remove(items:get(i));
			end
		end
	end
	
end

InitDone = false;


function getWeaponType(thisWeapon)
	for _,v in pairs(MeleWeapons) do
	  if v == thisWeapon then
		return "mele";
	  end
	end
	return "range";
end
function newWall(square, sprite, isNorth)
	local GateProperties = {

    stopOnWalk = false,
    stopOnRun = false,
    caloriesModifier = 1,
    maxTime = 0 ,                 -- 100=2sec , 250=6sec
    animationDuration = 2,          -- in seconds
    soundPlayed = "shoveling",      -- see media/lua/shared/SoundBanks/SoundBanks.lua
    thumpDmg = 8,
    maxHealth = 200,
    ---- fixme: I wrote 12 because it can arrive that update() is triggered less than 25 times :'(
    animationPonderator = 12

}
    local Wall = IsoThumpable.new(getCell(), square, sprite, isNorth, {});
    Wall:setCanPassThrough(false);
    Wall:setCanBarricade(false);
    Wall:setThumpDmg(GateProperties.thumpDmg);
    Wall:setMaxHealth(GateProperties.maxHealth);
    Wall:setIsContainer(false);
    Wall:setIsDoor(false);
    Wall:setIsDoorFrame(false);
    Wall:setCrossSpeed(1.0);
    Wall:setBlockAllTheSquare(false);
    Wall:setName("Object");
    Wall:setIsDismantable(false);
    Wall:setCanBePlastered(false);
    Wall:setIsHoppable(false);
    Wall:setIsThumpable(true);
    Wall:setModData({});
    -- the sound that will be played when our furniture will be broken
    Wall:setBreakSound("breakdoor");
    return Wall;
end
-- Add Wall on the square passed in parameter
function addWallOnSquare(square, sprite, isNorth)
	if(square == nil or square == false) then return false end
    local Wall = newWall(square, sprite, isNorth);
    square:AddSpecialObject(Wall);
    Wall:transmitCompleteItemToServer();
end

function getNextSquare(square, dir)

	if(not square) then return false end
	if(dir == 'N') then
	return getCell():getGridSquare(square:getX(),square:getY()-1,square:getZ());
	elseif(dir == 'S') then
	return getCell():getGridSquare(square:getX(),square:getY()+1,square:getZ());
	elseif(dir == 'E') then
	return getCell():getGridSquare(square:getX()+1,square:getY(),square:getZ());
	elseif(dir == 'W') then
	return getCell():getGridSquare(square:getX()-1,square:getY(),square:getZ());
	end

end

function MakeBase(square,w,l)
NSSprite = "carpentry_02_80";
EWSprite = "carpentry_02_81";
	if( not square ) then return false end
	for x=0,w do
		square = getNextSquare(square,'N');
		if( not square ) then return false end
	end
		square = getNextSquare(square,'S');
		if( not square ) then return false end
	for x=0,l do
		square = getNextSquare(square,'E');
		if( not square ) then return false end
	end
	for x=0,w do
		square = getNextSquare(square,'S');
		if( not square ) then return false end
	end
		square = getNextSquare(square,'W');
		if( not square ) then return false end

	for x=0,l do
		square = getNextSquare(square,'W');
		if( not square ) then return false end
	end

	
	for x=0,w do
		addWallOnSquare(square,NSSprite,true);
		square = getNextSquare(square,'N');
	end
		square = getNextSquare(square,'S');
	for x=0,l do
		addWallOnSquare(square,EWSprite,true);
		square = getNextSquare(square,'E');
	end
	for x=0,w do
		addWallOnSquare(square,NSSprite,true);
		square = getNextSquare(square,'S');
	end
	square = getNextSquare(square,'W');
	local doorsquare = ZombRand(l-1);
	for x=0,l do
		if(x ~= doorsquare) then addWallOnSquare(square,EWSprite,true) end
		square = getNextSquare(square,'W');
	end
	return true;
end


local function AbsoluteValue(value)
	if(value >= 0) then return value; 
	else return (value * -1);
	end
end

function getAmmoBullets(weapon,incModule)
	
	if(weapon == nil) then return nil end
	local out = '';
	local modulename =''; 
	local wepdata = ReloadUtil:getWeaponData(weapon:getType());
	if(not wepdata or not wepdata.ammoType) then 
		--if(wepdata) then print("no weapon data for:"..tostring(weapon:getType()) .. "["..tostring(wepdata.ammoType).."]");
		--else print("no weapon data for:"..tostring(weapon:getType())); end
		return nil 
	end	
	local clipdata = ReloadUtil:getClipData(wepdata.ammoType);
	
	if(clipdata) then		
		if(clipdata.ammoType) then
			--print("ifif"..tostring(clipdata.ammoType));
			out = tostring(clipdata.ammoType);
			modulename = clipdata.moduleName;
		else
			--print("if-else"..tostring(wepdata.ammoType));
			out = tostring(wepdata.ammoType);
			modulename = wepdata.moduleName;
		end
	elseif(wepdata.ammoType) then
		--print("else"..tostring(wepdata.ammoType));
		out = tostring(wepdata.ammoType);
		modulename = wepdata.moduleName;
	else
		--print("else?"); 
	end
	
	if(incModule) then out = modulename .. "." .. out; end
	return out;

end

function FindAndUseWeapon(player,meleOrGun)
	if(player ~= nil) and (meleOrGun ~= nil) then
		local inv = player:getInventory();
		local resultingWeapon = nil ; --player:getPrimaryHandItem();
		local weapons = inv:getItemsFromCategory("Weapon");
		if(weapons) then
			for i=0, weapons:size() do
				local Ammo = getAmmoBullets(weapons:get(i)) ;
				if((meleOrGun == "gun") and (Ammo ~= nil)) or ((meleOrGun == "mele") and (Ammo == nil)) then 
					resultingWeapon = weapons:get(i); 
					break;
				end
			end
		else
			player:Say("I got no weapons");
		end
		player:setPrimaryHandItem(resultingWeapon);
	end
end

function reloadWeapon(primary,player)
	if(primary ~= nil) and (player ~= nil) then
		primary:setCondition(primary:getConditionMax()); 
		local ammotype = getAmmoBullets(primary,false);			
		if(ammotype ~= nil) then  		
			
			if(SurvivorInfiniteAmmo) then 
			primary:getModData().roundChambered = 1 ;
			return true end
			
			local ammo, result;
			ammo = player:getInventory():FindAndReturn(ammotype);
			if(not ammo) and (player:getSecondaryHandItem() ~= nil) and (player:getSecondaryHandItem():getCategory() == "Container") then ammo = player:getSecondaryHandItem():getItemContainer():FindAndReturn(ammotype); 			end
			if(not ammo) and (player:getClothingItem_Back() ~= nil) then ammo = player:getClothingItem_Back():getItemContainer():FindAndReturn(ammotype); end
			
			if(ammo) then
				if (primary:getModData() ~= nil) then
					if(primary:getModData().currentCapacity == nil) then 
						primary:getModData().currentCapacity = primary:getModData().maxCapacity;
					elseif(primary:getModData().currentCapacity < primary:getModData().maxCapacity) then 
						primary:getModData().currentCapacity = primary:getModData().maxCapacity; 				
					end
					if(primary:getModData().roundChambered == nil) or (primary:getModData().roundChambered < 1) then primary:getModData().roundChambered = 1; end
				end	
				result = true;
				ammo:getContainer():Remove(ammo);
				--print("found and used ammo");
			elseif (primary:isRanged() == false) then
				result = true;
				--print("not ranged");
			else
				--print("could not find ammotype: " .. tostring(ammotype));
				result = false;
			end
			
			return result;
		end
		--print("getAmmoBullets was nil");
		return true;
	end
	--print("primary == nil");
	return true;
end

function size(a)
 local i = 1
    while a[i] do
      i = i + 1
    end
	return i;
end



function DistanceBetween(z1,z2,thisdistance)

	local z1x = z1:getX();
	local z1y = z1:getY();
	local z2x = z2:getX();
	local z2y = z2:getY();
	if(AbsoluteValue(z1x-z2x) > thisdistance) then return false end;
	if(AbsoluteValue(z1y-z2y) > thisdistance) then return false end;
	
	return true;
	
end
function getDistanceBetween(z1,z2)
	if(z1 == nil) or (z2 == nil) then return -1 end
	
	local z1x = z1:getX();
	local z1y = z1:getY();
	local z2x = z2:getX();
	local z2y = z2:getY();
	return (AbsoluteValue(z1x-z2x) + (AbsoluteValue(z1y-z2y))/2) ;
	
end
function getDistanceBetweenThese(z1x,z1y,z2x,z2y)

	return (AbsoluteValue(z1x-z2x) + (AbsoluteValue(z1y-z2y))/2) ;
	
end


function makeVisibleToZombies(player)


local spottedList = player:getCell():getObjectList();

	if(spottedList ~= nil) then
		for i=0, spottedList:size()-1 do
			local character = spottedList:get(i);
			if(character ~= nil) and (character:isZombie()) then
				
				if(character:CanSee(player)) then 
					character:spotted(player, false); 
				end
			
			end
		end
	end
	
end

function isEnemy(player,character)

-- zombie is enemy to anyone
if character:isZombie() then return true end 

-- hostiles consider anything non hostile an enemy
if (player:getModData().isHostile == true and character:getModData().isHostile ~= true) then return true end 

--party members consider any hostile emeny if rules of engagement set so
if ((ROE >= 3) and player:getModData().MetPlayer == true and  (character:getModData().isHostile == true)) then return true end

-- party member consider anyone non party enemy if rules of engagement set so
if (ROE >= 4 and player:getModData().MetPlayer == true and character:getModData().MetPlayer~= true) then return true end

-- consider any hostile an enemy when you are under attack
if ((player:getModData().hitByCharacter == true) and (character:getModData().isHostile == true and player:getModData().isHostile ~= true)) then return true end

--consider any semi hostile from an other party an enemy when you are under attack
if ((player:getModData().hitByCharacter == true) and (character:getModData().semiHostile == true and (player:getModData().MetPlayer ~= character:getModData().MetPlayer))) then return true end

--consider any semi hostile an enemy when you are under attack and friendly fire relatilation on 
if (FriendlyFireRetaliation == true and (FriendlyFireRetaliationPlayerONLY == false or character == getSpecificPlayer(0) )) and ((player:getModData().hitByCharacter == true) and (character:getModData().semiHostile == true and (player:getModData().MetPlayer == character:getModData().MetPlayer))) then return true end

	return false;
	
end

function getASeenZombie(player)

local atLeastThisClose = 15; 
if (player:getModData().reactDistance ~= nil) then atLeastThisClose = player:getModData().reactDistance + getAttackRange(player); end

local spottedList = player:getCell():getObjectList();
--if player:getModData().isHostile ~= true then spottedList = getWorld():getCell():getZombieList();--player:getSpottedList() ;
--else spottedList = getWorld():getCell():getObjectList() end
local oldSeenZombie = player:getModData().seenZombie;
local closestSoFar = 200;
local countseen = 0;
local closestNumber = nil;
local tempdistance = 1;
	if(spottedList ~= nil) then
		for i=0, spottedList:size()-1 do
			local character = spottedList:get(i);
			if(character ~= nil) and (character ~= player) and (character:isCharacter() or character:isZombie()) then
			
					if( isEnemy(player,character) ) then
					tempdistance = getDistanceBetween(character,player);
						if(tempdistance < 10) then countseen = countseen + 1; end
						if( player:CanSee(character) and (tempdistance < closestSoFar) and (tempdistance <= atLeastThisClose)) then
							closestSoFar = tempdistance ;
							player:getModData().seenZombie = true;
							closestNumber = i;							
						end		
					end
				
			end
		end
		player:getModData().seenCount = countseen;
	end
	
	if(oldSeenZombie ~= player:getModData().seenZombie) then
		local weapon = player:getInventory():getItemFromType(player:getModData().weapon);
		player:setPrimaryHandItem(weapon);
		--player:setSecondaryHandItem(weapon);
		player:Say(addName(player)..getSeenFirstZombie()) end
	if(closestNumber ~= nil) then return spottedList:get(closestNumber); end
end

function getNearestInsideSquare(player)
local closestSoFar = 100;
local outSquare = nil;
local cell = player:getCell();
	for x=(cell:getMinX()+10), (cell:getMaxX()-10) do
		for y=(cell:getMinY()+10), (cell:getMaxY()-10) do
			
			local sq = cell:getGridSquare(x,y,0);
			if(sq ~= nil) and (getDistanceBetween(sq,player) < closestSoFar) and (sq:isOutside() == false) then
				
				closestSoFar = getDistanceBetween(sq,player);
				outSquare = sq;
				
			end
			
		end
	end
	return outSquare;
end

function CheckForGivenWeapon(sq, player)
	
	if(sq ~= nil) then
		local ol = sq:getWorldObjects() ;
		for i=0, ol:size()-1 do
		if(ol:get(i)) then
			local item = ol:get(i):getItem();
			if(hasBag(player) ~= true) and (item:getActualWeight() < 50.0) and (item:getCategory() == "Container") and (player:getModData().MetPlayer ~= nil) and (player:getModData().Orders ~= "Drop Bag") and (item:getModData().isCar ~= true) then
				player:getInventory():AddItem(item);
				player:setSecondaryHandItem(item);
				player:Say("I\'ll Carry this.");
				sq:removeWorldObject(ol:get(i));
				return true;
			elseif(item:getCategory() == "Food") then			
				local food = player:getInventory():AddItem(item);
				--player:Eat(food,1.00);
				if(player:getStats():getHunger() >= 0.15) and (tostring(player:getCharacterActions()) == "[]") then 
					ISTimedActionQueue.add(ISEatFoodAction:new(player,food,1.00)); 
					player:getStats():setHunger(player:getStats():getHunger() + food:getHungChange());
				end
				--food:getHungChange();
				--player:getInventory():Remove(food);
				sq:removeWorldObject(ol:get(i));
				player:Say("Thanks for the food ("..tostring(math.floor(player:getStats():getHunger()*100)..")"));
				return true;
			elseif(item:getActualWeight() < 3.0) and (string.find(item:getDisplayName(),"Water")) or (string.find(item:getDisplayName(),"water")) or (string.find(item:getType(),"Water")) or (string.find(item:getType(),"water")) then 
				player:getInventory():AddItem(item);
				sq:removeWorldObject(ol:get(i));
				player:Say("thanks for the water.");
				return true;
			end
		end
		end
	end
	return false;
end

function getAttackRange(player)
	if(player:getPrimaryHandItem() ~= nil) and (player:getPrimaryHandItem():IsWeapon()) then
		return ((player:getPrimaryHandItem():getMaxRange() + player:getPrimaryHandItem():getMinRange())*0.60) ;  
	else 
		return 0.5; 
	end
end

function getWindowFromSquare(square)
	if (square == nil) then return nil; end
	Window = square:getWindow(true);
	if(Window == nil) then 
		Window = square:getWindow(false);
		if(Window) then 
			return Window;
		end
	else
		return Window;
	end 
	
	return nil;
end
function getWindow(player)
	local psquare = player:getCurrentSquare();
	if(psquare == nil) then return false end
	Window = getWindowFromSquare(psquare);
	if(Window) then return Window; end
	local square = psquare:getN();
	if(square) then
		Window = getWindowFromSquare(square);
		if(Window) then return Window; end
	end
	square = psquare:getS();
	if(square) then
		Window = getWindowFromSquare(square);
		if(Window) then return Window; end
	end
	square = psquare:getW();
	if(square) then
		Window = getWindowFromSquare(square);
		if(Window) then return Window; end
	end
	square = psquare:getE();
	if(square) then
		Window = getWindowFromSquare(square);
		if(Window) then return Window; end
	end
	return nil;
end

function canClimbDown(player)
	local psquare = player:getCurrentSquare();
	if(psquare) then
		if(player:canClimbDownSheetRope(psquare)) then return true; end
	else
		return false;
	end
	
	local square = psquare:getW();
	if(square) then
		if(player:canClimbDownSheetRope(square)) then return true; end
	end
	square = psquare:getN();
	if(square) then
		if(player:canClimbDownSheetRope(square)) then return true; end
	end
	square = psquare:getE();
	if(square) then
		if(player:canClimbDownSheetRope(square)) then return true; end
	end
	square = psquare:getS();
	if(square) then
		if(player:canClimbDownSheetRope(square)) then return true; end
	end
	return false;
end

function canClimbUp(player)
	local psquare = player:getCurrentSquare();
	if(psquare) then
		if(player:canClimbSheetRope(psquare)) then return psquare; end
	else
		return nil;
	end
	
	local square = psquare:getW();
	if(square) then
		if(player:canClimbSheetRope(square)) then return square; end
	end
	square = psquare:getN();
	if(square) then
		if(player:canClimbSheetRope(square)) then return square; end
	end
	square = psquare:getE();
	if(square) then
		if(player:canClimbSheetRope(square)) then return square; end
	end
	square = psquare:getS();
	if(square) then
		if(player:canClimbSheetRope(square)) then return square; end
	end
	return nil;
end

function IdleStuff(player)
	if(ZombRand(5) == 0) then
		local tempx = player:getX() + ZombRand(-3,3);      
		local tempy = player:getY() + ZombRand(-3,3);
		if(tostring(player:getCharacterActions()) == "[]" ) then player:faceLocation(tempx,tempy); end
	end
	local sq = player:getCurrentSquare();
	if(sq ~= nil ) then
		if(CheckForGivenWeapon(sq,player)) then return true end;
		if(CheckForGivenWeapon(sq:getW(),player)) then return true end;
		if(CheckForGivenWeapon(sq:getS(),player)) then return true end;
		if(CheckForGivenWeapon(sq:getN(),player)) then return true end;
		if(CheckForGivenWeapon(sq:getE(),player)) then return true end;	
	end	
	
	if player:getModData().MetPlayer == true and player:CanSee(getSpecificPlayer(0)) then
		local sickness = getSpecificPlayer(0):getStats():getSickness();
		local bitten = false;
		local BPs = getSpecificPlayer(0):getBodyDamage():getBodyParts();
		for i=0, BPs:size()-1 do
			if(BPs:get(i):bitten()) then bitten = true end
		end
		if(sickness >= 0.25) and (player:getModData().seenPlayerIll ~= true) then
			player:getModData().seenPlayerIll = true;
			player:Say(addName(player) .. getSeenPlayerIll());
		--else
			--player:getModData().seenPlayerIll = nil;
		end
		if(bitten == true) and (player:getModData().seenPlayerBitten ~= true) and (TurnOnTheBitten) then
			player:getModData().seenPlayerBitten = true;
			player:getModData().hitByCharacter = true;
			getSpecificPlayer(0):getModData().isHostile = true;
			player:Say(addName(player) .. getSeenPlayerBit());
		--else
			--player:getModData().seenPlayerBitten = nil;
		end
		
	end
end

function PlayerUpdate(player)
if(player:getModData().GCount == nil) then player:getModData().GCount = 0; 
else player:getModData().GCount = player:getModData().GCount + 1 ; end
local LGCount = player:getModData().GCount;
local MData = player:getModData();			

	if(player:isDead() == true) or (player:getCurrentSquare() == nil) or  (getSpecificPlayer(0) == nil) or  (getSpecificPlayer(0):getModData() == nil) then return false end
	
	if(player:isLocalPlayer() == false ) then
		local PlayerMData = getSpecificPlayer(0):getModData();
		local SID = player:getModData().ID;
		local DistanceBetweenPlayer = getDistanceBetween(player,getFollowObj(player));
		if (DistanceBetweenPlayer < 8) and ((PlayerMData.Driving == 1) or (Driving == 1)) and (PlayerMData.NumInCar ~= nil and PlayerMData.CarLimit ~= nil) and (PlayerMData.NumInCar < PlayerMData.CarLimit) and (MData.MetPlayer == true and (getSpecificPlayer(0):getModData().FollowMe or player:getModData().Orders == "Follow")) and (MData.Passenger ~= 1) then	
			if(DistanceBetweenPlayer > 2)  then
				if(LGCount % 40 == 0) then
					
					player:StopAllActionQueue();
					WalkTo(player,getSpecificPlayer(0));
				end
			elseif(DistanceBetweenPlayer <= 2) then
				player:setAlpha(0);
				PlayerMData.NumInCar = PlayerMData.NumInCar + 1;
				getSpecificPlayer(0):Say(tostring(PlayerMData.NumInCar).. " / " .. tostring( PlayerMData.CarLimit) .. " Capacity");
				MData.Passenger = 1;
			end				
		elseif(MData.Passenger == 1) and  (PlayerMData.Driving == 1) then
			player:setAlpha(0);
			player:setX(getSpecificPlayer(0):getX()+1);
			player:setY(getSpecificPlayer(0):getY()+1);
			if(LGCount % 100 == 0) then SaveSurvivor(player) 
			--elseif(LGCount % 20 == 0) then SaveSurvivorOnMap(player) 
			end
		else--if(MData.Passenger ~= 1) then
			
			--if(LGCount % 15 == 0) and (MData.Passenger ~= 1) then
			--	makeVisibleToZombies(player);
			--end
			
			if(player:getLastSquare() ~= nil ) then
				local tempdoor = player:getLastSquare():getDoorTo(player:getCurrentSquare());
				if(tempdoor ~= nil and tempdoor:IsOpen() ) then
					--ISTimedActionQueue.add(ISOpenCloseDoor:new(player, tempdoor, 0.1));
					 tempdoor:ToggleDoor(player);
				end		
			end
			if LGCount % 600 == 0 then 	
			MData.semiHostile = false; 
			MData.hitByCharacter = false;	end
			
			if(MData.isRunning) then player:setMoveSpeed(0.10) end
			
			
			if((LGCount % 20 == 0)) then
			--player:Say(tostring(player:getModData().ID));
			seenZombie[SID] = getASeenZombie(player);	
			if(seenZombie[SID]) then DistanceBetweenZombie = getDistanceBetween(player,seenZombie[SID]); end
			
			--player:setAlpha(1.0);
			
				
				local AttackRange = getAttackRange(player);
				
			
					if(player:getModData().Greeting ~= nil) and (DistanceBetweenPlayer <= 2) and ( player:CanSee(getSpecificPlayer(0)) ) then
					
						player:Say(addName(player)..getGreeting(player));
						player:getModData().Greeting = nil;
						
					end
					
					--player:getStats():setThirst(player:getStats():getThirst() + 0.0001); -- for some reason thier thirst dont move so
					
					if(ZombRand(1,35) == 1) and (LGCount > 200) then
																			
						if(player:getStats():getHunger() >= 0.90) then
							
							ClearOrderVars(player);
							player:getModData().hasOrder = true;
							player:getModData().Orders = "Explore";
							player:getModData().Dismissed = false;
							player:getModData().isHostile = true; 
							player:getModData().MetPlayer = nil;
							
						end
						local saidhungry = false;
						
						if(player:getStats():getHunger() >= 0.60) then
							player:Say(addName(player)..getStarving().." ("..tostring(math.floor(player:getStats():getHunger()*100)..")"));
							saidhungry = true;
						elseif(player:getStats():getHunger() >= 0.40) then
							player:Say(addName(player)..getVHungry().." ("..tostring(math.floor(player:getStats():getHunger()*100)..")"));
							saidhungry = true;
						elseif(player:getStats():getHunger() >= 0.20) then
							player:Say(addName(player)..getHungry().." ("..tostring(math.floor(player:getStats():getHunger()*100)..")"));
							saidhungry = true;
						end
						
						if(saidhungry) then 
							player:getModData().GCount = 0;
							local food = player:getInventory():FindAndReturnCategory("Food");
							if(food == nil) and (hasBag(player)) then 
								food = player:getSecondaryHandItem():getItemContainer():FindAndReturnCategory("Food"); 
								if(food ~= nil) then 
									player:getInventory():AddItem(food);
									player:getSecondaryHandItem():getItemContainer():Remove(food);										
								end
							end
							
							if(food ~= nil) and (player:getPath() == nil) then 
								player:Say("*takes out and eats ".. food:getDisplayName() .."*");
								player:StopAllActionQueue();
								ISTimedActionQueue.add(ISEatFoodAction:new(player,food,1.00));
								player:getStats():setHunger(player:getStats():getHunger() + food:getHungChange());
							elseif(food ~= nil) then
								player:Say(addName(player).."Let\'s take a break, I want to eat this "..food:getDisplayName());
							elseif(tostring(player:getCharacterActions()) == "[]" ) then
								IdleStuff(player) 
							end
						end
					end
					if(ZombRand(1,35) == 1) then
						if(player:getStats():getThirst() >= 0.60) then
							player:Say(addName(player)..getSThirsty().." ("..tostring(math.floor(player:getStats():getThirst()*100))..")");
						elseif(player:getStats():getThirst() >= 0.40) then
							player:Say(addName(player)..getVThirsty().." ("..tostring(math.floor(player:getStats():getThirst()*100))..")");
						elseif(player:getStats():getThirst() >= 0.20) then
							player:Say(addName(player)..getThirsty().." ("..tostring(math.floor(player:getStats():getThirst()*100))..")");	
						end
					end
					if(ZombRand(1,35) == 1) then
						if(player:getStats():getEndurance() < 0.20) then
							player:Say(addName(player)..getSTired().." ("..tostring(math.floor(player:getStats():getEndurance()*100))..")");
						elseif(player:getStats():getEndurance() < 0.40) then
							player:Say(addName(player)..getVTired().." ("..tostring(math.floor(player:getStats():getEndurance()*100))..")");
						elseif(player:getStats():getEndurance() < 0.60) then
							player:Say(addName(player)..getTired().." ("..tostring(math.floor(player:getStats():getEndurance()*100))..")");	
						end
					end
					
					if( (MData.saidInjured == nil) and (player:getBodyDamage():getOverallBodyHealth() <= 98) ) then
						player:Say(addName(player)..getHurt());
						MData.saidInjured = true;
					elseif( (MData.saidInjured2 == nil) and (player:getBodyDamage():getOverallBodyHealth() <= 80) ) then
						player:Say(addName(player)..getInjured());
						MData.saidInjured2 = true;
					elseif( (MData.saidInjured3 == nil) and (player:getBodyDamage():getOverallBodyHealth() <= 60) ) then
						player:Say(addName(player)..getBadInjured());
						MData.saidInjured3 = true;
					elseif( (MData.saidInjured4 == nil) and (player:getBodyDamage():getOverallBodyHealth() <= 40) ) then
						player:Say(addName(player)..getSeriousInjured());
						MData.saidInjured4 = true;
					elseif( (MData.saidInjured5 == nil) and (player:getBodyDamage():getOverallBodyHealth() <= 20) ) then
						player:Say(addName(player)..getFatalInjured());
						MData.saidInjured5 = true;
					elseif( (MData.saidInjured6 == nil) and (player:getBodyDamage():getOverallBodyHealth() <= 5) ) then
						player:Say(addName(player)..getFinalWords());
						MData.saidInjured6 = true;
					end
					
					--if(isKeyDown(MedicalCheck) == true) and (MData.MetPlayer == true) and (DistanceBetweenPlayer <= 1)  then
					--	ISTimedActionQueue.add( ISMedicalCheckAction:new(getSpecificPlayer(0), player));										
					--end
					
					
					if (LGCount % 300 == 0) and (LGCount > 300) then
						--player:Say(tostring(player:getModData().ID));
						if(MData.ID ~= 0) then 
							player:getStats():setFatigue(0.0);	
							player:getStats():setBoredom(0.0);
							player:getStats():setMorale(0.0);
						end
						if(player:getModData().MetPlayer == true and NoHungerForParty == true) or ((player:getModData().MetPlayer == false or player:getModData().MetPlayer == nil) and NoHungerForNonParty == true) or (player:getModData().NoParty == true and NoHungerForPresets == true) or (NoHungerForAll == true) then
							player:getStats():setThirst(0.0);
							player:getStats():setHunger(0.0);
						end
						
						local sheetRopeSquare = canClimbUp(player);
						if(sheetRopeSquare and player:getZ() == 0) then 
							player:getModData().GCount = 0;
							player:climbSheetRope();	
							local window = getWindow(player);
							if(window) then
								player:climbThroughWindow(window);
							end
						elseif(sheetRopeSquare and player:getZ() > 0) then 	
							player:getModData().GCount = 0;
							local window = getWindow(player);
							if(window) then
								if( window:haveSheetRope()) then
									player:climbThroughWindow(window);
									player:climbDownSheetRope();
								end
							else
								--ISTimedActionQueue.add(ISWalkToTimedAction:new(player, square))
								ISTimedActionQueue.add(ISClimbSheetRopeAction:new(player, true))
							end
						elseif(getWindow(player)) then
							local window = getWindow(player)
							if(window:getZ() < 1) and (window:isGlassRemoved()) then
								player:getModData().GCount = 0;
								player:climbThroughWindow(window);
							end
							
						end					
						
					elseif(player:getZ() < 1) and (LGCount % 40 == 0) and (player:getModData().Orders == nil or player:getModData().Orders ~= "Standing Ground") then
						player:hopFence(player:getLastdir() , false);							
					end
					
					
					if(LGCount % 80 == 0) then 
						SaveSurvivor(player) 
					-- SaveSurvivorOnMap(player) 
					end
				
					MData.isRunning = false;
					
					--player:Say(tostring(DistanceBetweenPlayer));
					if( getShouldFollow(player, DistanceBetweenPlayer, MData) ) then
					MData.isRunning = true;	
						
						if((player:getPath() == nil) or (LGCount % 60 == 0)) then
							--player:Say("moving");								
							if(MData.Orders ~= "Follow") and (MData.Orders ~= "Attack") then ClearOrderVars(player); end
							local followObj = getFollowObj(player);
							local sq;
							if(instanceof(followObj,"IsoPlayer")) then sq = followObj:getCurrentSquare(); 
							else sq = followObj; end 
							MData.Passenger = 0;
							if(sq ~= nil) then 
							--ISTimedActionQueue.clear(player);
							player:StopAllActionQueue();
							 
							WalkTo(player,sq);
							else player:Say("?!?") end
						end
					elseif ( (SelectSent) and (OrderTo == MData.ID) and (MData.MetPlayer == true) ) then
						SelectSent = false;
						player:Say(getRespond());
					elseif ((OrderSent) and (OrderTo == MData.ID) and (MData.MetPlayer == true) ) then
						
						ClearOrderVars(player);
						MData.hasOrder = true;
						OrderSent = false;
						MData.Orders = Orders[CurrentOrder];
						player:Say(getRoger()); 
					
							
					elseif((seenZombie[SID]~= nil) and (MData.attackDistance ~= nil) and (((DistanceBetweenZombie - AttackRange)  <= MData.attackDistance))  ) then
						--player:Say("Zombie seen and close");	
							--MData.hasOrder = false; 
							MData.Passenger = 0;
							tempx = seenZombie[SID]:getX();      
							tempy = seenZombie[SID]:getY();
							local minDistance = AttackRange;
							local theDistance = DistanceBetweenZombie;
							if((player:IsAttackRange(seenZombie[SID]:getX(),seenZombie[SID]:getY(),seenZombie[SID]:getZ())) ) or (theDistance < 0.8 ) then
							
								local reactToPanic = ((ZombRand(1,4) == 1) and (math.floor(player:getStats():getPanic()) > 50) and (MData.seenCount > 3));
								if (reactToPanic) or ( ((ROE == 1) and player:getModData().MetPlayer == true) ) or ((theDistance < 1.0) and (AttackRange > 3) and (player:getModData().Orders == nil or player:getModData().Orders ~= "Standing Ground")) then
									local sq = getFleeSquare(player,seenZombie[SID]);
									if(reactToPanic) and (ZombRand(3)==0) then player:Say(addName(player) .. getScared()) end
									if(sq ~= nil) then WalkTo(player,sq); 
									else player:Say("?!?") end
								elseif(player:getModData().Greeting ~= nil) and (seenZombie[SID] == getSpecificPlayer(0)) then
					
									player:Say(addName(player)..getGreeting(player));
									player:getModData().Greeting = nil;
						
								elseif not ((ROE == 1) and player:getModData().MetPlayer == true) then
									if((LGCount % 160 == 0) and seenZombie[SID]:isZombie()) then player:Say(addName(player)..getAttack()); 
									elseif((LGCount % 160 == 0) and seenZombie[SID]:isCharacter()) then player:Say(addName(player)..getAttackS()) end
									
								
									local canattack = reloadWeapon(player:getPrimaryHandItem(),player);
								
									if(canattack) then
										if(instanceof(seenZombie[SID],"IsoPlayer") and IsoPlayer.getCoopPVP() == false) then
											ForcePVPOn = true;
											SurvivorTogglePVP();
										end
										if(player.StopWalk ~= nil) then player:StopWalk(); end
										player:faceThisObject(seenZombie[SID]);
										player:AttemptAttack() ;
									else
										player:Say(addName(player)..getOutOfAmmo());
										local mele = player:getInventory():FindAndReturn(player:getModData().weaponmele);
										if(mele) then player:setPrimaryHandItem(mele) 
										else
											 local bwep = player:getInventory():getBestWeapon();
											 if(bwep) and (bwep ~= player:getPrimaryHandItem()) then player:setPrimaryHandItem(bwep) ;
											 else player:setPrimaryHandItem(nil) end
										end
									end
								end
								
							elseif( not ((ROE == 1) and player:getModData().MetPlayer == true) and (((DistanceBetweenZombie - AttackRange) < 3) or (LGCount % 40 == 0)) and not (((getSpecificPlayer(0):getModData().FollowMe or player:getModData().Orders == "Follow" or player:getModData().Orders == "Attack") and player:getModData().MetPlayer) and ((DistanceBetweenZombie - AttackRange + DistanceBetweenPlayer) > PartyDistance)) and player:getModData().Orders ~= "Standing Ground" and not (player:getModData().Orders == "Patrol" and AttackRange > 3)) then
								
								if((LGCount % 160 == 0) and seenZombie[SID]:isZombie()) then player:Say(addName(player)..getFoundZombie()); 
								elseif ((LGCount % 160 == 0)) then player:Say(addName(player)..getFoundSurvivor()) end
								
								local sq = seenZombie[SID]:getCurrentSquare();
								--local sq = getCell():getGridSquare(tempx,tempy,seenZombie[SID]:getZ());
								if(sq ~= nil) then 
									player:StopAllActionQueue(); 
									--ISTimedActionQueue.clear(player);
									WalkTo(player,sq); 
								else
									player:Say("?!?");
								end
							elseif (MData.hasOrder == true) then	
								OrderHandling(player);
							elseif(tostring(player:getCharacterActions()) == "[]" ) then
								IdleStuff(player);
							end
						
						
					elseif (MData.hasOrder == true) then	
						OrderHandling(player);
					elseif (MData.seenZombie == true) and (LGCount % 50 == 0) and (player:getPath() == nil) then
					--	player:Say("(LGCount % 50 == 0)");
						MData.hitByCharacter = false;	
						MData.semiHostile = false;		
						if(MData.MetPlayer == true) then
							player:getStats():setEndurance(player:getStats():getEndurance() + 0.01); -- fast endurance recovery since they cant rest or sleep
					
							if((IdleChatter) and (player:CanSee(getPlayer())) and (LGCount % 100 == 0) and (ZombRand(6) == 0)) then player:Say(addName(player)..getIdleChatter()); end
								
							if(tostring(player:getCharacterActions()) == "[]") then IdleStuff(player); end
						
							if(player:getStats():getHunger() >= 0.15) and (tostring(player:getCharacterActions()) == "[]") and (ZombRand(5) == 0) then
								if(player:getModData().LookingForFood == nil) then
									player:getModData().LookingForFood = true;
									player:getModData().PatrolSquareAX = player:getX();
									player:getModData().PatrolSquareAY = player:getY();
									player:getModData().PatrolSquareAZ = player:getZ();
								end
								FindSomeFood(player);
							elseif(player:getCurrentSquare():getRoom() ~= nil) and (ZombRand(5) == 0)  and (tostring(player:getCharacterActions()) == "[]") then
								local room = player:getCurrentSquare():getRoom() ;
								local sq = room:getRandomFreeSquare();
								if(sq ~= nil) then WalkTo(player,sq); end
							end
							
						else
							if(MData.AIType == "Fight") then
								player:Say(addName(player)..getLookingForZombie()); 
								player:StopAllActionQueue();
								local sq = getCell():getGridSquare(player:getX() + ZombRand(-25,25),player:getY() + ZombRand(-25,25),getSpecificPlayer(0):getZ());
								if(sq ~= nil) then WalkTo(player,sq); end	
							elseif (MData.AIType == "Hide") then
								if(player:isOutside()) then
									if((LGCount % 160 == 0)) then player:Say(addName(player)..getWantToHide()); end
									
									local sq = getNearestInsideSquare(player);
									if(sq ~= nil) then 
									if((LGCount % 160 == 0)) then player:Say(addName(player)..getFoundHidingPlace()); end
									player:StopAllActionQueue();
									WalkTo(player,sq); 
									else
										if((LGCount % 100 == 0)) then player:Say(addName(player)..getNoWhereToHide()); end
										player:StopAllActionQueue();
										local sq = getCell():getGridSquare(player:getX() + ZombRand(-25,25),player:getY() + ZombRand(-25,25),getSpecificPlayer(0):getZ());
										if(sq ~= nil) then WalkTo(player,sq); end	
									end
								else
									if((LGCount % 160 == 0)) then	player:Say(addName(player)..getPanic()); end
									player:StopAllActionQueue();
									local sq = getCell():getGridSquare(player:getX() + ZombRand(-2,2),player:getY() + ZombRand(-2,2),player:getZ());
									if(sq ~= nil) then WalkTo(player,sq); end
								end						
							elseif (MData.AIType == "Run") then
								if((seenZombie[SID]~= nil) and (DistanceBetweenZombie < (MData.reactDistance/2))) then
									player:Say(addName(player)..getScreem());			
									player:StopAllActionQueue();							
									local sq = getFleeSquare(player,seenZombie[SID]);
									if(sq ~= nil) then WalkTo(player,sq); 
									else player:Say("?!?") end
								else
									if((LGCount % 100 == 0)) then player:Say(addName(player)..getScared()); end
									player:StopAllActionQueue();
									local sq = getCell():getGridSquare(player:getX() + ZombRand(-10,10),player:getY() + ZombRand(-10,10),player:getZ());
									if(sq ~= nil) then WalkTo(player,sq); 
									else player:Say("?!?") end
								end						
							elseif(MData.AIType == "Crying") then
								if(ZombRand(2) == 0) then player:Say(addName(player)..getCrying()); end
							end
							
												
						end
					elseif (MData.seenZombie == false)  and (LGCount % 60 == 0) and (player:getPath() == nil) then
						if(LGCount % 180 == 0) then player:Say(addName(player)..getPreZombieChatter()); end
						tempx = player:getX() + ZombRand(-25,25);      
						tempy = player:getY() + ZombRand(-25,25);
						local sq = getCell():getGridSquare(tempx,tempy,getSpecificPlayer(0):getZ());
						if(sq ~= nil) then 
							player:StopAllActionQueue();
							WalkTo(player,sq);
						end	
					end
				
					
				
				
			end
		
		end
	
	elseif(player:isLocalPlayer()) then -- is local player
	local PlayerMData = getSpecificPlayer(0):getModData();
		if(InitDone == false) then
			OnSurvivorGameStart();
			player:getModData().NumInCar = 1;
			player:getModData().CarLimit = 4;
			
			if(player:getModData().WifeID == nil) and (WifeSpawn == true) then					
				
				player:getModData().WifeID = 0;
				if(player:isFemale()) then	
					isFemale = false;
				else
					isFemale = true;
				end
				
				local wife = SpawnSurvivor(player:getCurrentSquare(),0);
				local MData = wife:getModData();
				if(player:isFemale()) then	
					wife:setForname("Husband");
				else
					wife:setForname("Wife");
				end
				
				wife:getModData().Greeting = " What are we going to do darling!?";
				wife:getModData().seenZombie = true;
				MData.MetPlayer = true;
				MData.isHostile = false;
											
				MData.attackDistance = reactDistance;
				MData.reactDistance = reactDistance;
				wife:StopAllActionQueue();
				MData.AIType = "Fight";
				if(wife:getPrimaryHandItem() == nil) then
					local weapon = wife:getInventory():getItemFromType(wife:getModData().weapon);
					wife:setPrimaryHandItem(weapon);
				end
				--wife:setSecondaryHandItem(weapon);
				if(wife) then SaveSurvivor(wife); end
				ISTimedActionQueue.add(ISWalkToTimedAction:new(wife, getSpecificPlayer(0):getCurrentSquare())); 
				MData.hasOrder = true;
				MData.Orders = "Follow";
				player:getModData().WifeID = MData.ID;
				wife:getModData().Name = wife:getForname();
				wife:Say(wife:getModData().Greeting);
				
			end
			
			if(getSpecificPlayer(0):getModData().ROE == nil) then getSpecificPlayer(0):getModData().ROE = ROE ; end
			if(player:getModData().FollowMe == nil) then player:getModData().FollowMe = FollowMe end
			InitPresetSpawns();
			getSpecificPlayer(0):getModData().ID = 0;
			Survivors[0] = getSpecificPlayer(0);
			if(IsoPlayer.setRealPlayer ~= nil) then IsoPlayer.setRealPlayer(getSpecificPlayer(0)); end
			getSpecificPlayer(0):getModData().isHostile = false; 
			getSpecificPlayer(0):getModData().seenZombie = true;
		--	end
			getSpecificPlayer(0):getModData().AIType = "Fight";
			getSpecificPlayer(0):getModData().hasOrder = true;
			getSpecificPlayer(0):getModData().Orders = "Standing Ground";
			getSpecificPlayer(0):getModData().reactDistance = reactDistance;
			getSpecificPlayer(0):getModData().attackDistance = reactDistance;
			getSpecificPlayer(0):getModData().isRunning = false; 
			getSpecificPlayer(0):getModData().RealPlayer = true;
			InitDone = true;
			ControlledPlayer = getSpecificPlayer(0);
			
			if(IsoPlayer.setRealPlayer ~= nil) then 
				getSpecificPlayer(0):setDisabledControls(false);
			else
				getSpecificPlayer(0):setBlockMovement(false);
			end
			
			getSpecificPlayer(0):getModData().MetPlayer = true;
			
			
			if(PlayerMData.PVP == nil) then PlayerMData.PVP = PVPDefault end
			if(PlayerMData.PartyWithMe == nil) then PlayerMData.PartyWithMe = PartyWithMe 
			else PartyWithMe = PlayerMData.PartyWithMe end
			
			IsoPlayer.setCoopPVP(PlayerMData.PVP);
			SurvivorTogglePVP();
			SurvivorTogglePVP();
			
			CarModEnabled = isModEnabled("DriveCars");
			
		end
		
		
		
		if LGCount % 600 == 0 then 
			PlayerMData.semiHostile = false; 
			PlayerMData.hitByCharacter = false;	
			if(IsoPlayer.getCoopPVP() == true and PVPDefault == false) then
				IsoPlayer.setCoopPVP(false);
				getSpecificPlayer(0):Say("PVP Toggled Off");
				PVPButton:setImage(PVPTextureOff)
			end
		end
		
		
		
		if((LGCount % 80 == 0)) then
			
			
			local distanceToRealPlayer = getDistanceBetween(Survivors[0],getSpecificPlayer(0));
			if(distanceToRealPlayer > 50) then
				ControlSurvivor("",Survivors[0]);
			end
			
			getSpecificPlayer(0):getModData().SurvivorCount = SurvivorCount;
		
		end
	end
	
end


function SpawnSurvivor(square, ID, mName)

		mName = mName or nil;
		
		if(isFemale == nil) then
		BuddyDesc = SurvivorFactory.CreateSurvivor();
		else 		
		BuddyDesc = SurvivorFactory.CreateSurvivor(nil, isFemale);
		isFemale = nil;
		end
		SurvivorFactory.randomName(BuddyDesc);
		local Z = 0;
		if(square:isSolidFloor()) then Z = square:getZ() end;
		local realplayer = getSpecificPlayer(0);
		Buddy = IsoPlayer.new(getWorld():getCell(),BuddyDesc,square:getX(),square:getY(),Z);
		IsoPlayer.setInstance(realplayer);
		
		if(IsoPlayer.setRealPlayer ~= nil) then 
			Buddy:setDisabledControls(true);
		else
			Buddy:setBlockMovement(true);
		end
		
		for i=0, 4 do
			Buddy:LevelPerk(Perks.FromString("Strength"));
		end
		if(Use3DModels)	then
			if(Buddy:isFemale()) then Buddy:setModel("kate.txt");
			else Buddy:setModel("male.txt"); end
		end
		--getJoypadManager():addJoypad(1, Buddy:getUsername());
		--setPlayerJoypad(Buddy:getPlayerNum(), 1, Buddy, Buddy:getUsername());
		--setPlayerMovementActive(Buddy:getPlayerNum(), false);
		if(ZombRand(1,100) <= ChanceToJoinPartyOnInvite ) then Buddy:getModData().WillJoinParty = true;
		else Buddy:getModData().WillJoinParty = false; end
		
		if mName then 
			 Buddy:setForname(mName);
		else 
			setRandomName(Buddy);
		end 
		
		Buddy:getModData().Follow = false;
		Buddy:getModData().Name = Buddy:getForname();
		local PlayerMData = getSpecificPlayer(0):getModData();
		if(SurvivorCount == nil) then SurvivorCount = 1 end
		if(ID == 0) then 
			
			while checkSaveFileExists("Survivor"..tostring(SurvivorCount)) do
				SurvivorCount = SurvivorCount + 1;
			end			
			Buddy:getModData().ID = SurvivorCount;
			SurvivorCount = SurvivorCount +1;
			
		else Buddy:getModData().ID = ID end
		local result;		
		if(SurvivorSpawnWeapon == "Random" or SurvivorSpawnWeapon == "random") then
			if(ZombRand(1,100) <= ChanceToSpawnWithGun) then
				result = ZombRand(size(RangeWeapons)-1)+1;
				--Wep = Buddy:getInventory():AddItem(RangeWeapons[result]);
				Buddy:getModData().weapon = RangeWeapons[result];
				giveWeapon(Buddy,Buddy:getModData().weapon,seenZombieDefault);
			end
				result = ZombRand(size(MeleWeapons)-1)+1;
				--Wep = Buddy:getInventory():AddItem(MeleWeapons[result]);
				Buddy:getModData().weaponmele = MeleWeapons[result];
				
				if(Buddy:getModData().weapon == nil) then 
					Buddy:getModData().weapon = MeleWeapons[result]; 
					giveWeapon(Buddy,Buddy:getModData().weaponmele,seenZombieDefault);
				else
					Wep = Buddy:getInventory():AddItem(MeleWeapons[result]);
				end
			
		else
			
			--Wep = Buddy:getInventory():AddItem(SurvivorSpawnWeapon);
			
			Buddy:getModData().weapon = SurvivorSpawnWeapon;
		end
		Buddy:getModData().GCount = ZombRand(100);
		if(getGameTime():getWorldAgeHours() < 24.0) then Buddy:getModData().seenZombie = seenZombieDefault; 
		else Buddy:getModData().seenZombie = true;  end
		
		Buddy:getModData().hitByCharacter = false;
		Buddy:getModData().semiHostile = false;
		local AIRand = ZombRand(100) + 1;
		if(AIRand < ChanceToBeHostileNPC) then
			--if(IsoPlayer.getCoopPVP()) then 
			Buddy:getModData().isHostile = true; 
			Buddy:getModData().seenZombie = true;
		--	end
			Buddy:getModData().AIType = "Fight";
			Buddy:getModData().reactDistance = reactDistance;
			Buddy:getModData().attackDistance = reactDistance;
		else
			AIRand = ZombRand(100) + 1;
			if(AIRand < 15) then
				Buddy:getModData().isHostile = false;
				Buddy:getModData().AIType = "Fight";
				Buddy:getModData().reactDistance = reactDistance;
				Buddy:getModData().attackDistance = reactDistance;
			elseif(AIRand < 85) then
				Buddy:getModData().AIType = "Run";
				Buddy:getModData().reactDistance = reactDistance;
				Buddy:getModData().attackDistance = 0.8;
			else
				Buddy:getModData().AIType = "Hide";
				Buddy:getModData().reactDistance = reactDistance;
				Buddy:getModData().attackDistance = 0.8;
			end
		end
		
		if(Buddy:getModData().weapon == "RollingPin") then
				
			Buddy:setSecondaryHandItem(Buddy:getInventory():AddItem("Base.PetrolCan"));
				
		end
		--Buddy:setAuthorizeMeleeAction(false);
		--Buddy:setBannedAttacking(true);				
		FillPlayerInventory(Buddy);
		Buddy:getModData().isRunning = false;
	
		--local perk  = Perks.FromString(getPerk());
		local level = ZombRand(MinPerkLevels,10);
		local count = 0;
		while(count < level) do
			Buddy:LevelPerk(Perks.FromString(getPerk()));
			count = count + 1;
		end
		
		--do extra marauder perks
		if(mName) then
			count = 0;
			while(count < ExtraMarauderPerks) do
				Buddy:LevelPerk(Perks.FromString(getMPerk()));
				count = count + 1;
			end
		end
		
		Survivors[Buddy:getModData().ID] = Buddy;
		
		SaveSurvivor(Buddy);
		return Buddy;
end
function ReuseGridsquareHandle(square)
	local mo = square:getMovingObjects();
	for i=0 , mo:size()-1 do
		if(instanceof(mo:get(i),"IsoPlayer")) and (mo:get(i):getModData().ID ~= nil) and (mo:get(i):getModData().ID ~= 0) then
			getSpecificPlayer(0):Say("Unloaded:"..tostring(mo:get(i):getModData().ID));
		end
	end
end
function LoadSquareHandle(square)
	if(square ~= nil) then
		if(square:getModData().SurvivorsOnMe ~= nil) then
			a = square:getModData().SurvivorsOnMe;
			local i = 1;
			table.sort(a);
			while(a[i] ~= nil) do								
				LoadSurvivor(a[i], square);
				i = i + 1;		
			end
			i = 1;
			while(a[i]) do								
				table.remove(a,a[i]);			
				i = i + 1;
			end			
		end
		
		local presetSpawned = PresetSpawn(square, getSpecificPlayer(0));
				
		if(presetSpawned == false) and (SurvivorSpawnRateMultiplier ~= 0) and (square:getModData().SurvivorSquareLoaded == nil) then	
			
			square:getModData().SurvivorsOnMe = {}; 
			square:getModData().SurvivorSquareLoaded = true
			local RealSpawnRate = 4000 + (getGameTime():getWorldAgeHours() * SurvivorSpawnDieOff );
			if(square:getZoneType() ~= "TownZone") then RealSpawnRate = (RealSpawnRate * 2.5) ; end
			if(square:isOutside() == false) then RealSpawnRate = (RealSpawnRate / 4.5) ; end
			RealSpawnRate = (RealSpawnRate / SurvivorSpawnRateMultiplier);
			
			--max out at 250 times less likely to find a survivor regardless of world age
			if(RealSpawnRate>1000000) then RealSpawnRate = 1000000 end
			
			if(ZombRand(RealSpawnRate) == 0) then
				local w = ZombRand(4,10);
				local l = ZombRand(4,10);	
				if square:isOutside() and square:getZoneType() ~= "TownZone" and square:getZoneType() ~= nil and ZombRand(12) ~= 0 and (MakeBase(square,w,l)) then --
								
					DropLootBag(getCell():getGridSquare(square:getX() + (w/2),square:getY() - (l/2),square:getZ()));
					DropLootBag(getCell():getGridSquare(square:getX() + (w/2),square:getY() - (l/2),square:getZ()));
					square = getCell():getGridSquare(square:getX() + (w/2) - 1,square:getY() - (l/2) + 1,square:getZ());
					
					if(square) then
						local tempSurvivor = SpawnSurvivor(square,0);
						local campfire = camping.addCampfire(square);
						camping.addFuel(campfire, 100.0);
						camping.lightFire(campfire);
						tempSurvivor:setX(tempSurvivor:getX()+1.0);
						tempSurvivor:getModData().hasOrder = true;
						tempSurvivor:getModData().Orders = "Standing Ground";
						local weapon = tempSurvivor:getInventory():getItemFromType(tempSurvivor:getModData().weapon);
						tempSurvivor:setPrimaryHandItem(weapon);
						
						local tempSurvivor2 = SpawnSurvivor(square, 0);
						tempSurvivor2:setY(tempSurvivor:getY()-1.0);
						tempSurvivor2:getModData().isHostile = tempSurvivor:getModData().isHostile;
						tempSurvivor2:getModData().hasOrder = true;
						tempSurvivor2:getModData().Orders = "Standing Ground";
						local weapon = tempSurvivor2:getInventory():getItemFromType(tempSurvivor2:getModData().weapon);
						tempSurvivor2:setPrimaryHandItem(weapon);
						tempSurvivor2:getModData().hasOrder = true;
						tempSurvivor2:getModData().Orders = "Standing Ground";
					
					end
					
				elseif square:getZoneType() == "DeepForest" and ZombRand(3) ~= 0 and square:isOutside() then
					local tempSurvivor = SpawnSurvivor(square,0);
					local campfire = camping.addCampfire(square);
					camping.addFuel(campfire, 100.0);
					camping.lightFire(campfire);
					tempSurvivor:setX(tempSurvivor:getX()+1.0);
					tempSurvivor:getModData().hasOrder = true;
					tempSurvivor:getModData().Orders = "Standing Ground";
					local weapon = tempSurvivor:getInventory():getItemFromType(tempSurvivor:getModData().weapon);
					tempSurvivor:setPrimaryHandItem(weapon);
					if(ZombRand(2) == 0) then --50% chance to add another survivor around the fire
						local tempSurvivor2 = SpawnSurvivor(square, 0);
						tempSurvivor2:setY(tempSurvivor:getY()-1.0);
						tempSurvivor2:getModData().isHostile = tempSurvivor:getModData().isHostile;
						tempSurvivor2:getModData().hasOrder = true;
						tempSurvivor2:getModData().Orders = "Standing Ground";
						local weapon = tempSurvivor2:getInventory():getItemFromType(tempSurvivor2:getModData().weapon);
						tempSurvivor2:setPrimaryHandItem(weapon);
						tempSurvivor2:getModData().hasOrder = true;
						tempSurvivor2:getModData().Orders = "Standing Ground";
					end
				elseif square:getZoneType() == "DeepForest" and ZombRand(2) == 0 then
					local tempSurvivor = SpawnSurvivor(square,0);
					tempSurvivor:getModData().hasOrder = true;
					tempSurvivor:getModData().Orders = "Forage";
					
				elseif ZombRand(8) == 0 then
					local deadGuy = SpawnSurvivor(square, 0);						
					local tempSurvivor = SpawnSurvivor(square, 0);	
					tempSurvivor:faceThisObject(deadGuy)	;
					deadGuy:Kill(nil);					
					tempSurvivor:setY(tempSurvivor:getY()-1.0);
					tempSurvivor:getModData().AIType = "Crying";
					tempSurvivor:getModData().Orders = "Standing Ground" ;
					tempSurvivor:getModData().seenZombie = true;
				elseif (ZombRand(11) == 0) then -- follow group
					local size = ZombRand(3,5);
					local hostile = false;
					local noparty = true;
					if(ZombRand(1,100) <= ChanceToBeHostileNPC) then
						hostile = true;
					end
					if(ZombRand(1,100) <= ChanceToJoinPartyOnInvite) then
						noparty = false;
					end
										
					for i=1, size do
						local tempSurvivor = SpawnSurvivor(square, 0);
						tempSurvivor:getModData().hasOrder = true;
						
						if(i==1) then 
						Leader = tempSurvivor:getModData().ID; 
						tempSurvivor:getModData().Orders = "Explore";
						else 
						tempSurvivor:getModData().FollowID = Leader ;
						tempSurvivor:getModData().Orders = "Follow";
						end
						
						tempSurvivor:getModData().isHostile = hostile;
						tempSurvivor:getModData().NoParty = noparty;
						tempSurvivor:getModData().WillJoinParty = (not noparty);
						tempSurvivor:getModData().seenZombie = true;
						local weapon = tempSurvivor:getInventory():getItemFromType(tempSurvivor:getModData().weapon);
						tempSurvivor:setPrimaryHandItem(weapon);
					end
				elseif (ZombRand(15) == 0) then -- hostile group
					local size = ZombRand(3,5);
					local hostile = false;
					local noparty = true;
					if(ZombRand(1,100) <= ChanceToBeHostileNPC) then
						hostile = true;
					end
					if(ZombRand(1,100) <= ChanceToJoinPartyOnInvite) then
						noparty = false;
					end
										
					for i=1, size do
						local tempSurvivor = SpawnSurvivor(square, 0);
						if(i==1) then Leader = tempSurvivor:getModData().ID; 
						else tempSurvivor:getModData().FollowID = Leader end
						DropLootBag(square);
						if(ZombRand(1,2) == 1) then PatrolTo(tempSurvivor,ZombRand(-10,10), ZombRand(-10,10));	
						else	
							tempSurvivor:getModData().hasOrder = true;
							tempSurvivor:getModData().Orders = "Follow";
						end
						tempSurvivor:getModData().isHostile = hostile;
						tempSurvivor:getModData().NoParty = noparty;
						tempSurvivor:getModData().WillJoinParty = (not noparty);
						tempSurvivor:getModData().seenZombie = true;
						local weapon = tempSurvivor:getInventory():getItemFromType(tempSurvivor:getModData().weapon);
						tempSurvivor:setPrimaryHandItem(weapon);
					end
				else
					SpawnSurvivor(square, 0);
				end
			end
			
		end
		
	end
end
function Delete(player)

	player:getInventory():emptyIt();
	player:setPrimaryHandItem(nil);
	player:setSecondaryHandItem(nil);
	player:getModData().ID = 0;
	local filename = getSaveDir() .. "SurvivorTemp";
	player:save(filename);
	player:setX(9303);
	player:setY(5709);
	player:Despawn();
	player = nil;
	--player:Kill(nil);
	
	
end
function getMouseSquare(playerINT)
	local sw = (128 / getCore():getZoom(0));
	local sh = (64 / getCore():getZoom(0));
	
	local mapx = getSpecificPlayer(0):getX();
	local mapy = getSpecificPlayer(0):getY();
	local mousex = ( (getMouseX() - (getCore():getScreenWidth() / 2)) ) ;
	local mousey = ( (getMouseY() - (getCore():getScreenHeight() / 2)) ) ; 
	
	local sx = mapx + (mousex / (sw/2) + mousey / (sh/2)) /2;
	local sy = mapy + (mousey / (sh/2) -(mousex / (sw/2))) /2;
	
	local sq = getCell():getGridSquare(sx,sy,getSpecificPlayer(0):getZ());
	return sq;
end
function getFollowObj(player)
	if(player:getModData().FollowID ~= nil) then
		return Survivors[player:getModData().FollowID];
	elseif(player:getModData().Orders == "Attack") then
		return getMouseSquare(0);
	else
		return getSpecificPlayer(0);
	end
end

function getShouldFollow(player, DistanceBetweenFollowObj, MData)

	if(MData.MetPlayer == true) and ( isKeyDown(ForceFollow) ) then return true end
	if(MData.MetPlayer == true) and (DistanceBetweenFollowObj > PartyDistance) and (getSpecificPlayer(0):getModData().FollowMe or player:getModData().Orders == "Follow" or player:getModData().Orders == "Attack") then return true end
	if(player:getModData().Orders == "Follow") and (DistanceBetweenFollowObj > 5) then return true end
	
end
DSC = 0;
function LoadSurvivor(ID, square)
	if( not checkSaveFileExists("Survivor"..tostring(ID))) then return false end
	
	if(ID ~= nil) and (square ~= nil) then -- 
		
		if(Survivors[ID] ~= nil) and ((square == Survivors[ID]:getCurrentSquare()) or (Survivors[ID]:getCurrentSquare()~= nil)) then
			return false;
		elseif (Survivors[ID] ~= nil) then 
			Delete(Survivors[ID]);
			DSC = DSC + 1;
			--getSpecificPlayer(0):Say("Deleting Survivor"..tostring(DSC));
		end
		BuddyDesc = SurvivorFactory.CreateSurvivor();
		local realplayer = getSpecificPlayer(0);
		Buddy = IsoPlayer.new(getWorld():getCell(),BuddyDesc,square:getX(),square:getY(),square:getZ());
		IsoPlayer.setInstance(realplayer);
		Buddy:getInventory():emptyIt();
		local filename = getSaveDir() .. "Survivor"..tostring(ID);
		Buddy:load( filename );
		if (Buddy:getModData().ID == nil) or (Buddy:getCurrentSquare() == nil) then -- this means load failed
			Delete(Buddy);
			return false;
		else
		
			local spawnedSquare = Buddy:getCurrentSquare();
			local mo = spawnedSquare:getMovingObjects();
			for i=0 , mo:size()-1 do
				if(instanceof(mo:get(i),"IsoPlayer")) and (mo:get(i):getModData().ID == ID) then
					Delete(Buddy);
					return false;
				end
			end
			
			--Recipe.SetPlayerIndex(Buddy,3);
			if(IsoPlayer.setRealPlayer ~= nil) then 
				Buddy:setDisabledControls(true);
			else
				Buddy:setBlockMovement(true);
			end
			
			if(Use3DModels)	then
				if(Buddy:isFemale()) then Buddy:setModel("kate.txt");
				else Buddy:setModel("male.txt"); end
			end
			--GameWindow.ActivatedJoyPad = JoypadManager.instance:addJoypad(1, Buddy:getUsername());
			--setPlayerJoypad(Buddy:getPlayerNum(), 1, Buddy, Buddy:getUsername());
			--setPlayerMovementActive(Buddy:getPlayerNum(), false);
			--Buddy:setAuthorizeMeleeAction(false);
			--Buddy:setBannedAttacking(true);	
			Buddy:setForname(Buddy:getModData().Name);			
			if(SurvivorCount == nil) then SurvivorCount = 1 end;
			if(ID > SurvivorCount) then SurvivorCount = ID end
			Buddy:getModData().LastSquareSaveX = nil;
			Survivors[ID] = Buddy;
			SaveSurvivor(Survivors[ID]);
		end
	end
	
end

function SaveSurvivorOnMap(player)
	if player:getModData().RealPlayer == true then return false end
	local ID = player:getModData().ID;
	local square = player:getCurrentSquare();
	if(square ~= nil) then
		local a = square:getModData().SurvivorsOnMe;
		
		if(a == nil) then
			square:getModData().SurvivorsOnMe = {};
			a = square:getModData().SurvivorsOnMe;
		end
		if (has_value(a,ID) == false) then
			
			local removeFailed = false;
			if(player:getModData().LastSquareSaveX ~= nil) then
				local lastsquare = getCell():getGridSquare(player:getModData().LastSquareSaveX, player:getModData().LastSquareSaveY, player:getModData().LastSquareSaveZ);
				if( lastsquare ~= nil ) then
					table.remove(lastsquare:getModData().SurvivorsOnMe , ID);
				else 
					removeFailed = true;
				end
			end
			
			if(removeFailed == false) then
				table.insert(a, ID);			
				player:getModData().LastSquareSaveX = square:getX();
				player:getModData().LastSquareSaveY = square:getY();
				player:getModData().LastSquareSaveZ = square:getZ();
			end
		
		end
	
	end
end

function SaveSurvivor(player)
	if player:getModData().RealPlayer == true then return false end
	local ID = player:getModData().ID;
	if(ID ~= nil) then
		--local filename = getWorld():getGameMode() .. "-" .. getWorld():getWorld() .. "-" .. "Survivor"..tostring(ID);
		local filename = getSaveDir() .. "Survivor"..tostring(ID);
		player:save(filename);
		if(player ~= nil and player:isDead() == false and player:getCurrentState() ~= DieState.instance() ) then
			
			SaveSurvivorOnMap(player);
		
		end
	end
end

function SurvivorsKeyUp(keyNum) 
		--getSpecificPlayer(0):Say(tostring(keyNum));
	if(getSpecificPlayer(0) ~= nil) then
		if( keyNum == PVPToggle  or keyNum == 25) then -- backspace key
			SurvivorTogglePVP();
		elseif ( (keyNum == DecreasePartyDistance) and (PartyDistance>0) ) then
			PartyDistance = PartyDistance - 1;
			getSpecificPlayer(0):Say("Stay Closer "..tostring(PartyDistance));
		elseif (keyNum ==  IncreasePartyDistance) then 
			PartyDistance = PartyDistance + 1;
			getSpecificPlayer(0):Say("Spread Out "..tostring(PartyDistance));
		elseif ( keyNum ==  FollowMeToggle) then 
			if(getSpecificPlayer(0):getModData().FollowMe == true) then
				getSpecificPlayer(0):getModData().FollowMe = false;
				getSpecificPlayer(0):Say("Stay Here, Don\'t follow me.");
			else
				getSpecificPlayer(0):getModData().FollowMe = true;
				getSpecificPlayer(0):Say("Follow me");
			end
		elseif ( keyNum == SelectPartyMember ) then
			
			local size = SurvivorCount;
			if(size > 1) then
				Selected = Selected + 1;
				local stop = (size+Selected);
				for i=Selected, stop do
					if(Selected > size) then Selected = 0;	end
					if(Survivors[Selected] ~= nil) then
						if (Survivors[Selected]:getModData().MetPlayer == true) and (Survivors[Selected]:getCurrentSquare() ~= nil) and (Survivors[Selected]:isDead() == false) then
							break;
						end
					end		
					Selected = Selected + 1;
				end
				
				if(Survivors[Selected] ~= nil) and (Survivors[Selected]:getModData().MetPlayer == true) and (Survivors[Selected]:getCurrentSquare() ~= nil) and (Survivors[Selected]:isDead() == false and (getDistanceBetween(getSpecificPlayer(0),Survivors[Selected]) <= 50)) then
					--OrderTo = Selected;		
					--SelectSent = true;
					--getSpecificPlayer(0):Say(Survivors[OrderTo]:getForname());
					ControlSurvivor("",Survivors[Selected]);
				end
			else
			getSpecificPlayer(0):Say(tostring(SurvivorCount));
			end
		
		
		
		--if((getSpecificPlayer(0):getForname() ~= "Bob") or (getSpecificPlayer(0):getModData().RealPlayer ~= true)) then
		--	ControlSurvivor("",Survivors[0]);
		--elseif(LastControlledSurvivor ~= nil) then
		--	ControlSurvivor("",	LastControlledSurvivor);
		--end
		
		
				
		elseif ( keyNum == PartyWithMeToggle ) then
			if(PartyWithMe == true) then
				getSpecificPlayer(0):Say("PartyMe Disabled");
				PartyWithMe = false
			elseif(PartyWithMe == false) then
				getSpecificPlayer(0):Say("PartyMe Enabled");
				PartyWithMe = true		
			end	
			getSpecificPlayer(0):getModData().PartyWithMe = PartyWithMe;
		elseif (keyNum == ManualSurvivorSpawnKey) then
			SpawnedSurvivor = SpawnSurvivor(getSpecificPlayer(0):getCurrentSquare(), 0);
			if(SpawnedSurvivorsPartied) then
				local MData = SpawnedSurvivor:getModData();
				if(SpawnedSurvivor:getModData().Greeting == nil) then SpawnedSurvivor:Say(addName(SpawnedSurvivor)..getNameText() .. SpawnedSurvivor:getForname()) end;
				SpawnedSurvivor:Say(addName(SpawnedSurvivor)..getGreeting(SpawnedSurvivor));
				SpawnedSurvivor:getModData().Greeting = nil;
				SpawnedSurvivor:getModData().seenZombie = true;
				MData.MetPlayer = true;
				MData.Dismiss = false;
											
				MData.attackDistance = reactDistance;
				MData.reactDistance = reactDistance;
				SpawnedSurvivor:StopAllActionQueue();
				MData.AIType = "Fight";
				if(SpawnedSurvivor:getPrimaryHandItem() == nil) then
					local weapon = SpawnedSurvivor:getInventory():getItemFromType(SpawnedSurvivor:getModData().weapon);
					SpawnedSurvivor:setPrimaryHandItem(weapon);
				end
				--SpawnedSurvivor:setSecondaryHandItem(weapon);
				if(SpawnedSurvivor) then SaveSurvivor(SpawnedSurvivor); end
				--ISTimedActionQueue.add(ISWalkToTimedAction:new(SpawnedSurvivor, getSpecificPlayer(0):getCurrentSquare())); 
				WalkTo(SpawnedSurvivor,getSpecificPlayer(0));
				MData.hasOrder = true;
				MData.Orders = "Follow";
			end
			
		elseif (( keyNum == SendOrder ) or (keyNum == OrderHotkey1) or (keyNum == OrderHotkey2) or (keyNum == OrderHotkey3)) and (getSpecificPlayer(0) ~= nil) then
			if(OrderHotkey1 == keyNum ) then theOrder = OrderHotkey1Command;
			elseif(OrderHotkey2 == keyNum ) then theOrder = OrderHotkey2Command;
			elseif(OrderHotkey3 == keyNum ) then theOrder = OrderHotkey3Command;
			else theOrder = "normal" end
			
			if(theOrder == "normal") then
				OrderTo = Selected;	
				OrderSent = true;	
				getSpecificPlayer(0):Say(Orders[CurrentOrder]);
			elseif(Selected ~= nil) and (Survivors[Selected] ~= nil) then
				ClearOrderVars(Survivors[Selected]);
				Survivors[Selected]:getModData().hasOrder = true;
				Survivors[Selected]:getModData().semiHostile = false;
				Survivors[Selected]:getModData().isHostile = false;
				Survivors[Selected]:getModData().Orders = theOrder;
				Survivors[Selected]:Say(getRoger()); 
				getSpecificPlayer(0):Say(theOrder);
			end
			getSpecificPlayer(0):getModData().semiHostile = false;
			getSpecificPlayer(0):getModData().isHostile = false;			
			
		elseif ((keyNum == OrderAll) or (keyNum == OrderAllHotkey1) or (keyNum == OrderAllHotkey2) or (keyNum == OrderAllHotkey3)) and (getSpecificPlayer(0)~= nil) then
			if(OrderAllHotkey1 == keyNum ) then theOrder = OrderAllHotkey1Command;
			elseif(OrderAllHotkey2 == keyNum ) then theOrder = OrderAllHotkey2Command;
			elseif(OrderAllHotkey3 == keyNum ) then theOrder = OrderAllHotkey3Command;
			else theOrder = Orders[CurrentOrder]; end
			local size = SurvivorCount;
			if(size) then
				getSpecificPlayer(0):Say("Everyone "..theOrder);
				getSpecificPlayer(0):getModData().semiHostile = false;
				getSpecificPlayer(0):getModData().isHostile = false;
				for i=1, size do
					if(Survivors[i] ~= nil) and (Survivors[i]:getCurrentSquare() ~= nil) and (Survivors[i]:getModData().MetPlayer == true) and (Survivors[i]:getModData().IgnoreOrderAll ~= true) then
						ClearOrderVars(Survivors[i]);
						Survivors[i]:getModData().hasOrder = true;
						Survivors[i]:getModData().semiHostile = false;
						Survivors[i]:getModData().isHostile = false;
						Survivors[i]:getModData().Orders = theOrder;
						Survivors[i]:Say(getRoger()); 
					end				
				end
			end
		elseif (keyNum == 50) and (getSpecificPlayer(0)~= nil) and isKeyDown(54) then
			
			local square = getSpecificPlayer(0):getCurrentSquare();
			for i=1, SurvivorCount do
				if(Survivors[i] ~= nil) then 
					Delete(Survivors[i]); 
					Survivors[i] = nil;
				end
				LoadSurvivor(i,square);
			end
			getSpecificPlayer(0):Say("Finished reloading survivors. Relog to fix any lag or slowdown caused by this");
		
		elseif (keyNum == 53) and (getSpecificPlayer(0)~= nil) and isKeyDown(54) then
		
			--Delete(Survivors[SurvivorCount-1]);
			--getSpecificPlayer(0):Say(tostring(getSpecificPlayer(0):getPrimaryHandItem():getCategory()))
			--out = tostring(IsoPlayer.assumedPlayer);
			--out = out .. "," .. tostring(IsoPlayer.numPlayers);
			--out = out .. "," .. tostring((IsoPlayer.instance:getForname()));
			--out = out .. "," .. tostring(getSpecificPlayer(0):getPlayerNum());
			--getSpecificPlayer(0):Say(out);
			MakeBase(getMouseSquare(),ZombRand(3,9),ZombRand(3,9));
			
		elseif (keyNum == 1) and (getSpecificPlayer(0)~= nil)  then -- force save party when esc pressed
			
			getSpecificPlayer(0):getModData().SurvivorCount = SurvivorCount;
			for i=1, SurvivorCount do
				--
				if(Survivors[i] ~= nil) and (Survivors[i]:getModData().MetPlayer == true)  then
					SaveSurvivor(Survivors[i]);
				end
			end	
			if((getSpecificPlayer(0):getForname() ~= "Bob") or (getSpecificPlayer(0):getModData().RealPlayer ~= true)) then
				
				ControlSurvivor("",Survivors[0]);
				--getSpecificPlayer(0):SaveGame();
			end
			
		end
	end
end

function wasAttackedHandle(player)
	local LCount = player:getModData().GCount;
	
	if(LCount) and (LCount > 150) then
		if(player == getSpecificPlayer(0)) or (player:getModData().MetPlayer == true) then
			for i=1, SurvivorCount do
				if(Survivors[i] ~= nil) and (Survivors[i]:CanSee(player)) and (Survivors[i]:getCurrentSquare() ~= nil) and (Survivors[i]:getModData().MetPlayer == true) then
					Survivors[i]:getModData().hitByCharacter = true;
					Survivors[i]:getModData().seenZombie = true;
				end				
			end
		elseif(player:getModData().NoParty == true) then
			for i=1, SurvivorCount do
				if(Survivors[i] ~= nil) and (Survivors[i]:CanSee(player)) and (Survivors[i]:getCurrentSquare() ~= nil) and (Survivors[i]:getModData().NoParty == true) then
					Survivors[i]:getModData().hitByCharacter = true;
					Survivors[i]:getModData().seenZombie = true;
				end				
			end
		end
		player:getModData().GCount = 0;
	end
	
end

function PVPHandle(wielder, victim, weapon, damage)

	if(weapon:getType() == "RollingPin") and (wielder:getSecondaryHandItem() ~= nil and wielder:getSecondaryHandItem():getType() == "PetrolCan") then
		victim:SetOnFire();
		if(ZombRand(4) == 0) then
			victim:getCurrentSquare():StartFire();
		end
		wielder:getSecondaryHandItem():Use();
	end
	
	if(victim:getModData().AIType == "Hide") then
		victim:getModData().AIType = "Run";
	end
	if instanceof(victim, "IsoPlayer") then		
		wasAttackedHandle(victim);
		victim:getModData().hitByCharacter = true;		
		victim:getModData().seenZombie = true;	
		if(victim ~= getSpecificPlayer(0)) then victim:Say(getHitByPlayer()); end
	end
	if(instanceof(victim, "IsoPlayer") and victim:getModData().isHostile ~= true and wielder:getModData().Orders ~= "Attack") then		
		wielder:getModData().semiHostile = true;		
	end
	
end

function InitPresetSpawns()
	if(getSpecificPlayer(0):getModData().SurvivorCount ~= nil) then
		SurvivorCount = getSpecificPlayer(0):getModData().SurvivorCount;
	end
	--if(getSpecificPlayer(0):getModData().PresetSpawns == nil) then
	--	getSpecificPlayer(0):getModData().PresetSpawns = RPresetSpawns;		
	--end
end

function SurvivorsInit()
	if(not checkSaveFileExists(getSaveDir() .. "SurvivorMap.lua")) then
		local tempTable = {};
		tempTable[0] = {x=0,y=0};
		table.save( tempTable, getSaveDir() .. "SurvivorMap.lua" );
	end
	local SurvivorMap,err = table.load( getSaveDir() .. "SurvivorMap.lua" );
	if( err ~= nil ) then 
		checkSaveFileExists(getSaveDir() .. "SurvivorMap.lua")
		print("Error loading survivor map!"); 
	end
	
	if(getSpecificPlayer(0):getModData().ROE == nil) then getSpecificPlayer(0):getModData().ROE = 2 ; end
	InitPresetSpawns();
	
	
end
function NewGameHandle(player)
	
	
end
function MedicalCheckSurvivor(test,player)
	
	--ISTimedActionQueue.add(ISWalkToTimedAction:new(getSpecificPlayer(0), player:getCurrentSquare())); 
	--ISTimedActionQueue.add(ISMedicalCheckAction:new(getSpecificPlayer(0), player));
		if luautils.walkAdj(getSpecificPlayer(0), player:getCurrentSquare()) then
            ISTimedActionQueue.add(ISMedicalCheckAction:new(getSpecificPlayer(0), player))
        end	

end


function ControlSurvivor(test,player)
	if(player ~= nil) then 	
		
		
		if(IsoPlayer.setRealPlayer ~= nil) then 
			ControlledPlayer:setDisabledControls(true);
			player:setDisabledControls(false);
			ControlledPlayer = player;
			ControlledPlayer:setAsMainPlayer();
		else
			ControlledPlayer:setBlockMovement(true);
			player:setBlockMovement(false);
			ControlledPlayer = player;
			ControlledPlayer:Say("!!");
		end
		
		--player:Say("!!");
	end
	
end
function SelectSurvivor(test,player)
	OrderTo = player:getModData().ID;		
	SelectSent = true;
	getSpecificPlayer(0):Say(Survivors[OrderTo]:getForname());
end
function SwapWeaponsSurvivor(test,player)

	if(getDistanceBetween(player,getSpecificPlayer(0)) <= 2) then
		local PP = getSpecificPlayer(0):getPrimaryHandItem();
		local PS = getSpecificPlayer(0):getSecondaryHandItem();
		local SP = player:getPrimaryHandItem();
		local SS = player:getSecondaryHandItem();
		
		local PNW ;
		if(SP) then PNW = getSpecificPlayer(0):getInventory():AddItem(SP); end
		getSpecificPlayer(0):setPrimaryHandItem(PNW);
		if(PNW) and (PNW:isRequiresEquippedBothHands()) then getSpecificPlayer(0):setSecondaryHandItem(PNW); end
		if(SP) then player:getInventory():Remove(SP); end
		
		if(PP == PS) then getSpecificPlayer(0):setSecondaryHandItem(nil); end
		local SNW = player:getInventory():AddItem(PP);
		player:setPrimaryHandItem(SNW);
		getSpecificPlayer(0):getInventory():Remove(PP);
	else
		
		WalkTo(getSpecificPlayer(0), player);
	end
	
end
function InviteToParty(test,player)
	getSpecificPlayer(0):Say("Hey you! come with me!");
	if(player:getModData().seenZombie ~= true) then
		player:Say("Why should I go with you?");
	elseif (player:getModData().WillJoinParty ~= true) then
		player:Say("No! Leave me alone!");
	elseif player:CanSee(getSpecificPlayer(0)) then -- (MData.seenZombie == true) 
	
		local MData = player:getModData();
		if(player:getModData().Greeting == nil) then player:Say(addName(player)..getNameText() .. player:getForname()) end;
		player:Say(addName(player)..getGreeting(player));
		player:getModData().Greeting = nil;
		player:getModData().seenZombie = true;
		MData.MetPlayer = true;
		MData.Dismiss = false;
									
		MData.attackDistance = reactDistance;
		MData.reactDistance = reactDistance;
		player:StopAllActionQueue();
		MData.AIType = "Fight";
		if(player:getPrimaryHandItem() == nil) then
			local weapon = player:getInventory():getItemFromType(player:getModData().weapon);
			player:setPrimaryHandItem(weapon);
		end
		--player:setSecondaryHandItem(weapon);
		if(player) then SaveSurvivor(player); end
		--ISTimedActionQueue.add(ISWalkToTimedAction:new(player, getSpecificPlayer(0):getCurrentSquare())); 
		WalkTo(player,getSpecificPlayer(0));
		MData.hasOrder = true;
		MData.Orders = "Follow";
	else 
		player:Say("Who\'s there? Who said that?");
	end
end
function ToggleFollowMe(test,square,value)
	if(getSpecificPlayer(0):getModData().FollowMe == true) then
		getSpecificPlayer(0):getModData().FollowMe = false;
		getSpecificPlayer(0):Say("Stay Here, Don\'t follow me.");
	else
		getSpecificPlayer(0):getModData().FollowMe = true;
		getSpecificPlayer(0):Say("Follow me");
	end
end
function TogglePVP(test,square,value)
	SurvivorTogglePVP();	
end
function SurvivorOrder(test,player,order,orderParam)
	if(player ~= nil) then
		ClearOrderVars(player);
		player:getModData().hasOrder = true;
		player:getModData().semiHostile = false;
		player:getModData().isHostile = false;
		player:getModData().Orders = order;
		if(order == "Loot Room") and (orderParam ~= nil) then player:getModData().LootType = orderParam end
		player:Say(getRoger()); 
		getSpecificPlayer(0):Say(order);
	end
end
function IgnoreOrderAllToggle(test,player,order)
	if(player:getModData().IgnoreOrderAll ~= true) then
		player:getModData().IgnoreOrderAll = true;
		player:Say("I will Ignore any orders you give to everyone");
	else
		player:getModData().IgnoreOrderAll = false;
		player:Say("I will Listen any orders you give to everyone");
	end
end
function SurvivorOrderAll(test,player,order,orderParam)
	if(SurvivorCount) then
		getSpecificPlayer(0):Say("Everyone "..order);
		getSpecificPlayer(0):getModData().semiHostile = false;
		getSpecificPlayer(0):getModData().isHostile = false;
		for i=1, SurvivorCount do
			if(Survivors[i] ~= nil) and (Survivors[i]:getCurrentSquare() ~= nil) and (Survivors[i]:getModData().MetPlayer == true) and (Survivors[i]:getModData().IgnoreOrderAll ~= true) then
				ClearOrderVars(Survivors[i]);
				Survivors[i]:getModData().hasOrder = true;
				Survivors[i]:getModData().semiHostile = false;
				Survivors[i]:getModData().isHostile = false;
				Survivors[i]:getModData().Orders = order;
				if(order == "Loot Room") and (orderParam ~= nil) then Survivors[i]:getModData().LootType = orderParam end
				Survivors[i]:Say(getRoger()); 
			end				
		end
	end
end

function survivorMenu(context,o)
	if(instanceof(o, "IsoPlayer") and o:getModData().ID ~= nil) then -- make sure its a valid survivor
		local survivorOption = context:addOption(o:getForname(), worldobjects, nil);
		local submenu = context:getNew(context);
		if (o:getModData().MetPlayer == true) then
			local i = 1;
			local orderOption = submenu:addOption("Give Order", worldobjects, nil);
			local subsubmenu = submenu:getNew(submenu);
			while(Orders[i]) do
				if(Orders[i] == "Loot Room") then
					local subsubsubmenu = subsubmenu:getNew(subsubmenu);
					local lootTypeOption = subsubmenu:addOption(Orders[i], nil, SurvivorOrder, o, Orders[i])
					local q = 1;
					while(LootTypes[q]) do
						subsubsubmenu:addOption(LootTypes[q], nil, SurvivorOrder, o, Orders[i], LootTypes[q]);
						q = q + 1;
					end
					subsubmenu:addSubMenu(lootTypeOption, subsubsubmenu);
				else
					makeToolTip(subsubmenu:addOption(Orders[i], nil, SurvivorOrder, o, Orders[i]), Orders[i].." Description",OrderDesc[Orders[i]]);
				end
				i = i + 1;
			end
			submenu:addSubMenu(orderOption, subsubmenu);
		end
		if (o:getModData().isHostile ~= true) then
			local medicalOption = submenu:addOption("Medical Check", nil, MedicalCheckSurvivor, o, nil);
			local toolTip = makeToolTip(medicalOption,"Medical / First Aid Check","Walk to this survivor and medical check him, if they move the process can be interupted");
		end
		if (o:getModData().MetPlayer == true) and (getSpecificPlayer(0):getPrimaryHandItem() ~= nil) then
			local swapweaponsOption = submenu:addOption("Swap Weapons: ", nil, SwapWeaponsSurvivor, o, nil);
			local SurvivorWeaponName = "(No Weapon)";
			if(o:getPrimaryHandItem() ~= nil) then SurvivorWeaponName = o:getPrimaryHandItem():getDisplayName(); end
			local tooltip = makeToolTip(swapweaponsOption,"Swap / Trade Weapons","Trade your "..getSpecificPlayer(0):getPrimaryHandItem():getDisplayName().." with ".. o:getForname().."\'s ".. SurvivorWeaponName);
		end
		if (o:getModData().MetPlayer == true) then
			local selectOption = submenu:addOption("Call / Select", nil, SelectSurvivor, o, nil);
			local toolTip = makeToolTip(selectOption,"Select / Call Survivor","Call this party members name, they will respond so you know where they are and who they are. They will also be selected as the person to receive individual orders from hotkeys");
		end
		if (o:getModData().MetPlayer == true and (getDistanceBetween(getSpecificPlayer(0),o) <= 50)) then
			local selectOption = submenu:addOption("Control", nil, ControlSurvivor, o, nil);
			local toolTip = makeToolTip(selectOption,"Control Survivor","Take full control of this survivor.  Your player will meanwhile remain motionless in spot.  Pressing esc will return control to main player.  If controlled player comes near death control will return to main player.  If controlled player dies suddenly for somer reason before reaching low hp then both main player and controlled players will be gone. I Suggest you dont take controlled player too far away from main player, as it is hard to predict what might happen to save.");
		end
		if (o:getModData().isHostile ~= true) and (o:getModData().MetPlayer ~= true) and (o:getModData().NoParty ~= true) then
			submenu:addOption("Invite to Party", nil, InviteToParty, o, nil);
		end
		if (o:getModData().IgnoreOrderAll ~= true) and (o:getModData().MetPlayer == true) then
			submenu:addOption("Ignore Orders to All", nil, IgnoreOrderAllToggle, o, nil);
		elseif (o:getModData().IgnoreOrderAll == true) and (o:getModData().MetPlayer == true) then
			submenu:addOption("Obey Orders to All", nil, IgnoreOrderAllToggle, o, nil);
		end
		context:addSubMenu(survivorOption, submenu);
	end
end

--Reference for "Me" when controlling other survivors
function survivorMenuPlayer(context,o)
	if(instanceof(o, "IsoPlayer") and o:getModData().ID ~= nil) and (o:isDead() ~= true) then -- make sure its a valid survivor
		local survivorOption = context:addOption("Me", worldobjects, nil);
		local submenu = context:getNew(context);

		if ((o:getModData().MetPlayer == true)or (o:getModData().ID==0)) and (getDistanceBetween(getSpecificPlayer(0),o) <= 50) then
			local selectOption = submenu:addOption("Control", nil, ControlSurvivor, o, nil);
			local toolTip = makeToolTip(selectOption,"Control Survivor","Take full control of this survivor.  Your player will meanwhile remain motionless in spot.  Pressing esc will return control to main player.  If controlled player comes near death control will return to main player.  If controlled player dies suddenly for somer reason before reaching low hp then both main player and controlled players will be gone. I Suggest you dont take controlled player too far away from main player, as it is hard to predict what might happen to save.");
		end
		context:addSubMenu(survivorOption, submenu);
	end
end

function SurvivorsFloorObjectMenu(square,context)
	if(square ~= nil) then
	
		for i=0,square:getMovingObjects():size()-1 do
			local o = square:getMovingObjects():get(i)
			if(instanceof(o, "IsoPlayer")) and (getSpecificPlayer(0) ~= o) and (o:getModData().isHostile ~= true) and (o:getModData().ID ~= 0) then
				survivorMenu(context,o);
			end
			
			--Reference for "Me" when controlling other survivors
			if(instanceof(o, "IsoPlayer")) and (o:getModData().ID == 0) and (getSpecificPlayer(0) ~= o) then
				survivorMenuPlayer(context,o);
			end 
					
			
		end		
	end
end
function SurvivorsCheckForPlayer(player, context, worldobjects, test)

	--only player 1 can manipulate survivors
	if player ~= 0 then 
        return
    end
	
	local square = getMouseSquare(player);
					
	SurvivorsFloorObjectMenu(square,context);	
	if(square ~= nil) then
		local osquare = square:getN();
		if(osquare ~= nil) then
		SurvivorsFloorObjectMenu(osquare:getE(),context);
		SurvivorsFloorObjectMenu(osquare:getW(),context);
		SurvivorsFloorObjectMenu(osquare,context);
		end
		osquare = square:getS();
		if(osquare ~= nil) then
		SurvivorsFloorObjectMenu(osquare:getE(),context);
		SurvivorsFloorObjectMenu(osquare:getW(),context);
		SurvivorsFloorObjectMenu(osquare,context);
		end
		osquare = square:getE();
		if(osquare ~= nil) then
		SurvivorsFloorObjectMenu(osquare,context);
		end
		osquare = square:getW();
		if(osquare ~= nil) then
		SurvivorsFloorObjectMenu(osquare,context);
		end
	end
	local i = 1;
	local orderAllOption = context:addOption("Order All", worldobjects, nil);
	local submenu = context:getNew(context);
	while(Orders[i]) do
	
	if(Orders[i] == "Loot Room") then
		local subsubmenu = submenu:getNew(submenu);
		local lootTypeOption = submenu:addOption(Orders[i], nil, SurvivorOrderAll, o, Orders[i])
		local q = 1;
		while(LootTypes[q]) do
			subsubmenu:addOption(LootTypes[q], nil, SurvivorOrderAll, o, Orders[i], LootTypes[q]);
			q = q + 1;
		end
		submenu:addSubMenu(lootTypeOption, subsubmenu);
	else
		makeToolTip(submenu:addOption(Orders[i], nil, SurvivorOrderAll, square, Orders[i]),Orders[i].." Description",OrderDesc[Orders[i]]);
	end
		
		i = i + 1;
	end
	context:addSubMenu(orderAllOption, submenu);
	
	local SurvivorOptions = context:addOption("Survivor Options", worldobjects, nil);
	local submenu = context:getNew(context);
	
	local i = 1;
	local myPartyOption = submenu:addOption("My Party Members", worldobjects, nil);
	local subsubmenu = submenu:getNew(submenu);
	
	--Add support for joystick players to invite survivors to party (via Survivors Options) w.o. requiring a mouse
	local subsubmenuI = submenu:getNew(submenu);	
	local invitees = false;
	
		for i=1, SurvivorCount do
			if(Survivors[i] ~= nil) and (Survivors[i]:getCurrentSquare() ~= nil) and (Survivors[i]:getModData().MetPlayer == true) and (Survivors[i]:isDead() == false) then
				survivorMenu(subsubmenu,Survivors[i]);
			elseif (Survivors[i] ~= nil) and (Survivors[i]:getModData().isHostile ~= true) and (Survivors[i]:getModData().MetPlayer ~= true) and (Survivors[i]:getModData().NoParty ~= true) and (getDistanceBetween(getSpecificPlayer(0),Survivors[i]) <= 4) then
				--for joystick players, invitees need to be within 4 units distance.
				invitees = true;
				survivorMenu(subsubmenuI,Survivors[i]);
			end				
		end
		
		--Reference for "Me" when controlling other survivors
		if(Survivors[0] ~= nil) and (Survivors[0]:getModData().ID == 0) then
			survivorMenuPlayer(subsubmenu,Survivors[0]);
		end 
		
		submenu:addSubMenu(myPartyOption, subsubmenu);
		
		--joystick invitee support
		if (invitees) then
			local myPartyInvitees = submenu:addOption("Invite To Party", worldobjects, nil);
			submenu:addSubMenu(myPartyInvitees, subsubmenuI);
		end 
		
		
		
	local i = 1;
	local RulesOfEngagementOption = submenu:addOption("Rules of Engagement", worldobjects, nil);
	local subsubmenu = submenu:getNew(submenu);
	
	makeToolTip(subsubmenu:addOption("Attack Anything", nil, SetRulesOfEngagement, 4),"Rules of Engagement","Shoot or Attack on sight Anything that may come along. Zombies, hostile survivors, friendly survivors neutral. Only party members are the exception");
	makeToolTip(subsubmenu:addOption("Attack Hostiles", nil, SetRulesOfEngagement, 3),"Rules of Engagement","Shoot or Attack on sight Anything hostile that may come along. Zombies or obviously hostile survivors");
	makeToolTip(subsubmenu:addOption("Attack Zombies", nil, SetRulesOfEngagement, 2),"Rules of Engagement","Shoot or Attack on sight Any zombies that may come along.");
	makeToolTip(subsubmenu:addOption("No Attacking", nil, SetRulesOfEngagement, 1),"Rules of Engagement","Do not shoot or attack anything or anyone. Just avoid when possible.");
	
	submenu:addSubMenu(RulesOfEngagementOption, subsubmenu);
	
	local MeleOrGunOption = submenu:addOption("Call to Arms", worldobjects, nil);
	subsubmenu = submenu:getNew(submenu);
	
	makeToolTip(subsubmenu:addOption("Use Mele Weapon", nil, SetMeleOrGun, 'mele'),"Rules of Engagement","Command your party to equip and use mele weapons if they have any");
	makeToolTip(subsubmenu:addOption("Use Guns", nil, SetMeleOrGun, 'gun'),"Rules of Engagement","Command your party to equip and use guns if they have any");
	
	submenu:addSubMenu(MeleOrGunOption, subsubmenu);
		
	
	--local FollowMeOption;
	--if(getSpecificPlayer(0):getModData().FollowMe) then FollowMeOption = submenu:addOption("Turn Follow Me Off", nil, ToggleFollowMe, square, false);
	--else FollowMeOption = submenu:addOption("Turn Follow Me On", nil, ToggleFollowMe, square, true); end
	--makeToolTip(FollowMeOption,"FollowMe Mode Toggle","When on, survivors will follow you and stay within your set follow distance. This is a high priority follow.  If survivors are forced to follow you from this mode they will abandon any current Orders they have.");
	
	local PVPOption;
	if(getSpecificPlayer(0):getModData().PVP) then PVPOption = submenu:addOption("Turn PVP Off", nil, TogglePVP, square, false);
	else PVPOption = submenu:addOption("Turn PVP On", nil, TogglePVP, square, true); end
	makeToolTip(PVPOption,"PvP / Player vs Player Toggle","PvP is globally on or off. If its on, anyone can hit / hurt anyone who gets in the way of an attack. ");
	
	context:addSubMenu(SurvivorOptions, submenu);
	
end

function SetRulesOfEngagement(test,value)
	getSpecificPlayer(0):getModData().ROE = value ;
	ROE = value;
	getSpecificPlayer(0):Say("Rules of Engagement set "..tostring(value));
end
function SetMeleOrGun(test,value)
	local size = SurvivorCount;
			if(size) then
				getSpecificPlayer(0):Say("Everyone Use "..value);
				for i=1, size do
					if(Survivors[i] ~= nil) and (Survivors[i]:getCurrentSquare() ~= nil) and (Survivors[i]:getModData().MetPlayer == true) and (Survivors[i]:getModData().IgnoreOrderAll ~= true) then
						FindAndUseWeapon(Survivors[i],value);
						Survivors[i]:Say(getRoger()); 
						clearSurvivorVars(i);
						
					end				
				end
			end
end

function clearSurvivorVars(id)
	if(Tree[id]) then Tree[id] = nil; end
	if(Room[id]) then Room[id] = nil; end
	if(Building[id]) then Building[id] =  nil; end
	if(Container[id]) then Container[id] =  nil; end
end

function makeToolTip(option,name,desc)
	local toolTip = ISToolTip:new();
        toolTip:initialise();
        toolTip:setVisible(false);
        -- add it to our current option
        option.toolTip = toolTip;
        toolTip:setName(name);
        toolTip.description = desc .. " <LINE> ";
        --toolTip:setTexture("crafted_01_16");
		
		--toolTip.description = toolTip.description .. " <LINE> <RGB:1,0,0> More Desc" ;
		--option.notAvailable = true;
       return toolTip;
end

function SurvivorTogglePVP()
	
	if(IsoPlayer.getCoopPVP() == true) then
		getSpecificPlayer(0):Say("PVP Disabled");
		IsoPlayer.setCoopPVP(false);		
		getSpecificPlayer(0):getModData().PVP = false;
		PVPDefault = false;
		PVPButton:setImage(PVPTextureOff)
	elseif(IsoPlayer.getCoopPVP() == false) then
		
		IsoPlayer.setCoopPVP(true);	
		if(ForcePVPOn ~= true) then
			getSpecificPlayer(0):getModData().PVP = true;
			PVPDefault = true;
			getSpecificPlayer(0):Say("PVP Enabled");
		else
			getSpecificPlayer(0):Say("PVP Forced On");
		end
		ForcePVPOn = false;
		PVPButton:setImage(PVPTextureOn)
	end
end

function SurvivorsCreatePVPButton()
	PVPTextureOn = getTexture("media/textures/PVPOn.png");
	PVPTextureOff = getTexture("media/textures/PVPOff.png");
	
	if(not PVPTextureOff) then print("could not load media/textures/PVPOff.png"); 
	else print("Succesfully load media/textures/PVPOff.png"); end
		
	PVPButton = ThePVPButton:new(getCore():getScreenWidth() - 100, getCore():getScreenHeight() - 50, 25, 25, "", nil, SurvivorTogglePVP);
	PVPButton:setImage(PVPTextureOff);	
	PVPButton:setVisible(true);
	PVPButton:setEnable(true);
	--PVPButton.textureColor.r = 255;
	PVPButton:addToUIManager();
	
end

BadInstallCount = 49;
function BadInstallUpdate(player)
	BadInstallCount = BadInstallCount + 1;
	if(BadInstallCount % 50 == 0) then player:Say("SURVIVORS MOD: "..ErrorMessage) end
end

function getMarauderSpawnSquare() 

	local x;local y;
	local spawnLocation = ZombRand(4);
	local tries = 10;
	
	local PCs = {};
	local pNum = 0;
	
	-- do not spawn when player is asleep
	if (getSpecificPlayer(0) and not getSpecificPlayer(0):isAsleep()) then table.insert(PCs,0) end
	if (getSpecificPlayer(1) and not getSpecificPlayer(1):isAsleep()) then table.insert(PCs,1) end
	if (getSpecificPlayer(2) and not getSpecificPlayer(2):isAsleep()) then table.insert(PCs,2) end
	
	if #PCs == 0 then return {nil,nil}; end
	
	for i=1, tries do
	
		pNum =  tonumber(PCs[ ZombRand(#PCs)+1 ]);
		if(spawnLocation ==0) then
			--spawn from north
			x = getSpecificPlayer(pNum):getX() + (ZombRand(80) - 40);
			y = getSpecificPlayer(pNum):getY() - 40;
			
		elseif(spawnLocation ==1) then 
			--spawn from east
			x = getSpecificPlayer(pNum):getX() + 40;
			y = getSpecificPlayer(pNum):getY() + (ZombRand(80) - 40);	
		elseif(spawnLocation ==2) then 
			--spawn from south
			x = getSpecificPlayer(pNum):getX() + (ZombRand(80) - 40);
			y = getSpecificPlayer(pNum):getY() + 40;
		
		elseif(spawnLocation ==3) then 
			--spawn from west
			x = getSpecificPlayer(pNum):getX() - 40;
			y = getSpecificPlayer(pNum):getY() + (ZombRand(80) - 40);	
	
		end
		
		local cell = getWorld():getCell()
		local square = cell:getGridSquare(math.floor(x),math.floor(y),0);
		
		--make sure marauders dont spawn on top of other players
		if (square ~= nil) then
			if not ((getSpecificPlayer(1) and getDistanceBetween(getSpecificPlayer(1),square)<=20) or (getSpecificPlayer(2) and getDistanceBetween(getSpecificPlayer(2),square)<=20) or (getSpecificPlayer(0) and getDistanceBetween(getSpecificPlayer(0),square)<=20)) then
				return {square,pNum};
			end
		end
		spawnLocation = ZombRand(4);
	end 
	return {nil,nil}; 
end

function UpdateSurvivorsWorldState () 

	local worldHours = getGameTime():getWorldAgeHours();
	
	--get how many players (if coop)
	local numP = 0;
	if getSpecificPlayer(0) then numP = numP + 1 end
	if getSpecificPlayer(1) then numP = numP + 1 end
	if getSpecificPlayer(2) then numP = numP + 1 end
	
	MaxMarauderRateHours=MaxMarauderRate*(24*6)*(2/3);
	MinMarauderRateHours=MinMarauderRate*(24*6)*(2/3);
	
	local RealSpawnRate = MaxMarauderRateHours + ((worldHours-DayMaraudingStarts*24)* SurvivorSpawnDieOff )/15;
	
	if(getSpecificPlayer(0):getSquare():getZoneType() ~= "TownZone") then RealSpawnRate = (RealSpawnRate * 2.5) ; end
	if(getSpecificPlayer(0):getSquare():isOutside() == false) then RealSpawnRate = (RealSpawnRate / 1.5) ; end
	RealSpawnRate = (RealSpawnRate / SurvivorSpawnRateMultiplier);
	 
	--if more than 1 player, 'increase' spawn rate a little
	RealSpawnRate = (RealSpawnRate)/(1 + (numP-1)/3);
	
	--lets make sure that the spawn rate is never more rapid than every 3days ~450
	--taking account of 1/3 time sleeping approx

	if(RealSpawnRate<MaxMarauderRateHours) then RealSpawnRate = MaxMarauderRateHours end --300*(DayMaraudingStarts/15) end
	
	--make RealSpawnRate to be no less than MinMarauderRate regardless of world age
	--also compensate for not spawning when players are asleep (1/3 of day)

	if(RealSpawnRate>MinMarauderRateHours) then RealSpawnRate = MinMarauderRateHours end	
	
	if(MaxHostileNPC > ChanceToBeHostileNPC) then 
	
		ChanceToBeHostileNPC = ChanceToBeHostileNPCMin + (MaxHostileNPC - ChanceToBeHostileNPC)*((worldHours * SurvivorSpawnMoreHostile )/4000); 
	
		if(ChanceToBeHostileNPC >= MaxHostileNPC) then 
			ChanceToBeHostileNPC = MaxHostileNPC;
		end
	else
		MaxHostileNPC = ChanceToBeHostileNPC;
	end
	if(MaxChanceToSpawnWithGun > ChanceToSpawnWithGun) then 
	
		ChanceToSpawnWithGun = ChanceToSpawnWithGunMin + (MaxChanceToSpawnWithGun - ChanceToSpawnWithGun)*((worldHours * SurvivorSpawnMoreGun )/4000); 
	
		if(ChanceToSpawnWithGun >= MaxChanceToSpawnWithGun) then 
			ChanceToSpawnWithGun = MaxChanceToSpawnWithGun;
		end
	else
		MaxChanceToSpawnWithGun = ChanceToSpawnWithGun;
	end	
	--default minimum perk level is 4, max is 10
	MinPerkLevels = MinPerkLevelsMin + (MaxPerkLevels - MinPerkLevels)*((worldHours * SurvivorSpawnMorePerked )/4000);
	ExtraMarauderPerks = 0; 
	if(MinPerkLevels > MaxPerkLevels) then 
		--when regular perk levels are maxed out,
		--lets keep buffing up marauder combat skills over time, till they are all maxed
		ExtraMarauderPerks = math.floor(MinPerkLevels) - MaxPerkLevels;
		if(ExtraMarauderPerks > 100) then ExtraMarauderPerks =100; end
		MinPerkLevels = MaxPerkLevels;
	else 
		MinPerkLevels = math.floor(MinPerkLevels);
	end
	
	--lets see if any new marauders are moving around in the area,
	--if realspawn rate = 1000, about once a week marauders will show up, maxes at about once a month
	if((EnableMarauders and worldHours >DayMaraudingStarts*24) and (RealSpawnRate > 0 and ZombRand(RealSpawnRate)==0)) then	
		--increase size of groups over time starting from the day marauders can appear
		local Mincrease = (worldHours-DayMaraudingStarts*24) * MarauderMoreSize;
		local MinSize = 2 + (10-1)*(( Mincrease )/9000);
		local MaxSize = 5 + (5-1)*(( Mincrease )/4000);
		local marauderNames= {"A Marauder","A Marauder","A Marauder","A Raider","A Bandit",
"A Savior","A Wolves Member"};
		local result = ZombRand(size(marauderNames)-1)+1;
		local mname = marauderNames[result];
		
		if(MinSize>10) then 
			MinSize = ZombRand(3) + 8;
		else
			MinSize = math.floor(MinSize);
		end

		if(MaxSize>10) then 
			MaxSize = 10;
		else
			MaxSize = math.floor(MaxSize);
		end	

		if(MinSize > MaxSize) then MaxSize = MinSize end
		
		--if more than 1 player, increase group size a little
		MinSize = math.floor((MinSize)*(1 + (numP-1)/3));
		MaxSize = math.floor((MaxSize)*(1 + (numP-1)/3));
		
		local Leader;
		local size = ZombRand(MinSize,MaxSize);
		
		local mInfo = getMarauderSpawnSquare();
		local square = mInfo[1];
		local pNum = mInfo[2];
		if (square == nil) then
			return;
		end
		
										
		for i=1, size do
			local tempSurvivor = SpawnSurvivor(square, 0, mname);
			tempSurvivor:getModData().hasOrder = true;
						
			if(i==1) then 
				Leader = tempSurvivor:getModData().ID; 
				tempSurvivor:getModData().Orders = "Explore";
				local sq = getSpecificPlayer(pNum):getSquare();
				--make the Leader walk to where player character is at
				tempSurvivor:StopAllActionQueue();
				--ISTimedActionQueue.add(ISWalkToTimedAction:new(tempSurvivor, sq)); 
				WalkTo(player,sq);
			else 
				tempSurvivor:getModData().FollowID = Leader ;
				tempSurvivor:getModData().Orders = "Follow";
			end
	
			tempSurvivor:getModData().ShowName = true;
			tempSurvivor:getModData().isHostile = true;
			tempSurvivor:getModData().NoParty = true;
			tempSurvivor:getModData().WillJoinParty = false;
			tempSurvivor:getModData().seenZombie = true;
			local weapon = tempSurvivor:getInventory():getItemFromType(tempSurvivor:getModData().weapon);
			tempSurvivor:setPrimaryHandItem(weapon);
			
		end	
		
		local player = getSpecificPlayer(pNum);
		if((getGameTime():getTimeOfDay()>20.00) or (getGameTime():getTimeOfDay()<6.00)) and player:HasTrait('NightVision') then
			if ZombRand(4) == 0 then player:Say("I think I see something! "..mname.."!");return; end	
		end
		if player:HasTrait('KeenHearing') then
			if ZombRand(2) == 0 then player:Say("I think I hear something! "..mname.."!");return; end 
		end	
		if player:HasTrait('Inconspicuous') then
			if ZombRand(4) == 0 then player:Say("I think I see something! "..mname.."!");return; end 	
		end
		if player:HasTrait('EagleEyed') then	
			if ZombRand(2) == 0 then player:Say("I think I see something! "..mname.."!");return; end 	
		end			
			
	end
end

if(ErrorMessage == "None") then
	Events.OnGameStart.Add(SurvivorsCreatePVPButton);
	Events.OnFillWorldObjectContextMenu.Add(SurvivorsCheckForPlayer);
	--Events.OnNewGame.Add(NewGameHandle);
	--Events.ReuseGridsquare.Add(ReuseGridsquareHandle);
	Events.OnWeaponHitCharacter.Add(PVPHandle);
	Events.OnPreGameStart.Add(SurvivorsInit);
	Events.OnPlayerUpdate.Add(PlayerUpdate);

	Events.LoadGridsquare.Add(LoadSquareHandle);

	Events.OnKeyPressed.Add(SurvivorsKeyUp);
	Events.EveryTenMinutes.Add(UpdateSurvivorsWorldState);
else
	Events.OnPlayerUpdate.Add(BadInstallUpdate);
end